//-----------------------------------------------------------------------------
// Desc:	R}h`_CAO
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Rienbu.h"
#include "CommandDialog.h"
#include "CommandItem.h"
#include "MainFrm.h"
#include "EnvironmentList.h"
#include "FolderDialog.h"
#include "IconDialog.h"

// CCommandDialog _CAO

IMPLEMENT_DYNAMIC(CCommandDialog, CDialog)

/**
 * WRXgN^
 * @param pParent [in] eEBhE
 */
CCommandDialog::CCommandDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CCommandDialog::IDD, pParent)
	, m_nShowWindow(0)
	, m_strTitleEdit(_T(""))
	, m_strLinkEdit(_T(""))
	, m_strWorkFolderEdit(_T(""))
	, m_strCommentEdit(_T(""))
	, m_strEnvEdit(_T(""))
{
	// _CAOJƂ
	((CMainFrame*) ::AfxGetMainWnd())->DialogOpend();
	// R}hl
	m_pItem = NULL;
	// ̑ϐ
	m_fInit = FALSE;
	::ZeroMemory(&m_rect, sizeof(CRect));
	m_rectPrev = m_rect;
	m_rectTitleEdit = m_rect;
	m_rectLinkEdit = m_rect;
	m_rectFolderEdit = m_rect;
	m_rectShowCombo = m_rect;
	m_rectCommentEdit = m_rect;
	m_rectLinkButton = m_rect;
	m_rectFolderButton = m_rect;
	m_rectIconButton = m_rect;
	m_rectEnvEdit = m_rect;
	m_rectOkButton = m_rect;
	m_rectCancelButton = m_rect;
	m_hLargeIcon = NULL;
}

/**
 * fXgN^
 */
CCommandDialog::~CCommandDialog()
{
	delete m_pItem;
	((CMainFrame*) ::AfxGetMainWnd())->DialogClosed();
	if (m_hLargeIcon != NULL) {
		::DestroyIcon(m_hLargeIcon);
	}
}

/**
 * DDX/DDV T|[g
 * @param pDX [in] f[^ϊIuWFNg
 */
void CCommandDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_CBIndex(pDX, IDC_SHOWWINDOWCOMBO, m_nShowWindow);
	DDX_Text(pDX, IDC_TITLEEDIT, m_strTitleEdit);
	DDX_Text(pDX, IDC_LINKEDIT, m_strLinkEdit);
	DDX_Text(pDX, IDC_FOLDEREDIT, m_strWorkFolderEdit);
	DDX_Text(pDX, IDC_COMMENTEDIT, m_strCommentEdit);
	DDX_Text(pDX, IDC_ENVEDIT, m_strEnvEdit);
}


BEGIN_MESSAGE_MAP(CCommandDialog, CDialog)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_BN_CLICKED(IDC_LINKBUTTON, &CCommandDialog::OnBnClickedLinkbutton)
	ON_BN_CLICKED(IDC_ICONBUTTON, &CCommandDialog::OnBnClickedIconbutton)
	ON_EN_KILLFOCUS(IDC_LINKEDIT, &CCommandDialog::OnEnKillfocusLinkedit)
	ON_BN_CLICKED(IDC_WKFOLDERBUTTON, &CCommandDialog::OnBnClickedWkfolderbutton)
END_MESSAGE_MAP()

// CCommandDialog bZ[W nh

/**
 * WM_INITDIALOGnh 
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOɃXe[^Xo[쐬
	if (m_wndStatusBar.Create(this) == FALSE) {
		TRACE0("Xe[^X o[̍쐬Ɏs܂B\n");
		return FALSE;      // 쐬ł܂łB
	}

	// ^Cg60ɐ
	((CEdit*) GetDlgItem(IDC_TITLEEDIT))->LimitText(60);
	// s̑傫
	CString strShow, strHide, strMaximize;
	strShow.LoadString(IDS_SHOW);
	strHide.LoadString(IDS_HIDE);
	strMaximize.LoadString(IDS_MAXIMIZE);
	CComboBox* pBox = (CComboBox*) GetDlgItem(IDC_SHOWWINDOWCOMBO);
	pBox->AddString(strShow);
	pBox->AddString(strHide);
	pBox->AddString(strMaximize);

	// EBhETCY擾Ă
	GetWindowRect(&m_rect);
	m_rectPrev = m_rect;
	// Rg[̃TCY擾
	GetControlSize();

	// R}hACȅԂŏς
	if (m_pItem == NULL) {
		m_pItem = new CCommandItem();
		m_pItem->CreateDefaultIcon();
	}
	else {	// vpeB
		CString strCaption;
		strCaption.Format(IDS_CMDDLGTITLE1, m_pItem->GetMenuTitle());
		SetWindowText(strCaption);
	}

	UINT nIcon = IDR_MAINFRAME;
	// Ǘ[hł͊̓fBXG[u
	if (((CRienbuApp*) ::AfxGetApp())->GetStartupMode() != MODE_NORMAL) {
		GetDlgItem(IDC_ENVEDIT)->EnableWindow(FALSE);
		nIcon = IDI_ADMINICON;
	}
	// ACRύX
	SendMessage(WM_SETICON, 1, (LPARAM) ::AfxGetApp()->LoadIcon(nIcon));

	// 傫ACR̃Zbg
	m_hLargeIcon = m_pItem->ExtractLargeIcon();
	((CStatic*) GetDlgItem(IDC_CMDICON))->SetIcon(m_hLargeIcon);
	// e_CAOl̐ݒ
	SetDlgValues();

	// TCYύX\ł邱Ƃ𔻂₷邽߂ɃXe[^Xo[\
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	m_fInit = TRUE;	// 

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

/**
 * WM_SIZEnh
 * @param nType [in] ^Cv
 * @param cx [in] 
 * @param cy [in] 
 */
void CCommandDialog::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if (m_fInit != FALSE) {
		// Rg[̈ʒuƃTCYύX
		ResizeControls();
		// Xe[^Xo[̏ꏊύX
		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
	}
}

/**
 * Window̍ől/ŏl߂
 * @param lpMMI [in, out] Window̍ől/ŏlݒ肷\̃|C^
 */
void CCommandDialog::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	if (m_fInit != FALSE) {
		// ŏTCY߂
		lpMMI->ptMinTrackSize.x = m_rect.Width();
		lpMMI->ptMinTrackSize.y = m_rect.Height();
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}

/**
 * Rg[ނ̃TCY擾
 */
void CCommandDialog::GetControlSize()
{
	GetDlgItem(IDC_TITLEEDIT)->GetWindowRect(&m_rectTitleEdit);
	ScreenToClient(&m_rectTitleEdit);
	GetDlgItem(IDC_LINKEDIT)->GetWindowRect(&m_rectLinkEdit);
	ScreenToClient(&m_rectLinkEdit);
	GetDlgItem(IDC_FOLDEREDIT)->GetWindowRect(&m_rectFolderEdit);
	ScreenToClient(&m_rectFolderEdit);
	GetDlgItem(IDC_SHOWWINDOWCOMBO)->GetWindowRect(&m_rectShowCombo);
	ScreenToClient(&m_rectShowCombo);
	GetDlgItem(IDC_COMMENTEDIT)->GetWindowRect(&m_rectCommentEdit);
	ScreenToClient(&m_rectCommentEdit);
	GetDlgItem(IDC_LINKBUTTON)->GetWindowRect(&m_rectLinkButton);
	ScreenToClient(&m_rectLinkButton);
	GetDlgItem(IDC_ICONBUTTON)->GetWindowRect(&m_rectIconButton);
	ScreenToClient(&m_rectIconButton);
	GetDlgItem(IDC_WKFOLDERBUTTON)->GetWindowRect(&m_rectFolderButton);
	ScreenToClient(&m_rectFolderButton);
	GetDlgItem(IDC_ENVEDIT)->GetWindowRect(&m_rectEnvEdit);
	ScreenToClient(&m_rectEnvEdit);
	GetDlgItem(IDOK)->GetWindowRect(&m_rectOkButton);
	ScreenToClient(&m_rectOkButton);
	GetDlgItem(IDCANCEL)->GetWindowRect(&m_rectCancelButton);
	ScreenToClient(&m_rectCancelButton);
}

/**
 * Rg[ނTCY
 */
void CCommandDialog::ResizeControls()
{
	CRect rect;
	CRect rectTemp;
	GetWindowRect(&rect);

	// ̉ê݂󂯂Rg[
	int nDiff = rect.Width() - m_rect.Width();
	if (rect.Width() != m_rectPrev.Width()) {
		// ύX
		rectTemp = m_rectTitleEdit;	// O
		rectTemp.right += nDiff;
		GetDlgItem(IDC_TITLEEDIT)->MoveWindow(&rectTemp);
		rectTemp = m_rectLinkEdit;	// N
		rectTemp.right += nDiff;
		GetDlgItem(IDC_LINKEDIT)->MoveWindow(&rectTemp);
		rectTemp = m_rectFolderEdit;	// ƃtH_
		rectTemp.right += nDiff;
		GetDlgItem(IDC_FOLDEREDIT)->MoveWindow(&rectTemp);
		rectTemp = m_rectShowCombo;	// s̑傫
		rectTemp.right += nDiff;
		GetDlgItem(IDC_SHOWWINDOWCOMBO)->MoveWindow(&rectTemp);
		rectTemp = m_rectCommentEdit;	// Rg
		rectTemp.right += nDiff;
		GetDlgItem(IDC_COMMENTEDIT)->MoveWindow(&rectTemp);
		// ꏊ
		rectTemp = m_rectLinkButton;	// NT
		rectTemp.left += nDiff;
		rectTemp.right += nDiff;
		GetDlgItem(IDC_LINKBUTTON)->MoveWindow(&rectTemp);
		rectTemp = m_rectIconButton;	// ACRύX
		rectTemp.left += nDiff;
		rectTemp.right += nDiff;
		GetDlgItem(IDC_ICONBUTTON)->MoveWindow(&rectTemp);
		rectTemp = m_rectFolderButton;	// tH_T
		rectTemp.left += nDiff;
		rectTemp.right += nDiff;
		GetDlgItem(IDC_WKFOLDERBUTTON)->MoveWindow(&rectTemp);
		// ĕ`
		GetDlgItem(IDC_LINKBUTTON)->Invalidate();
		GetDlgItem(IDC_LINKBUTTON)->UpdateWindow();
		GetDlgItem(IDC_ICONBUTTON)->Invalidate();
		GetDlgItem(IDC_ICONBUTTON)->UpdateWindow();
		GetDlgItem(IDC_WKFOLDERBUTTON)->Invalidate();
		GetDlgItem(IDC_WKFOLDERBUTTON)->UpdateWindow();
	}

	// Aoe󂯂Rg[
	int nDiffH = rect.Height() - m_rect.Height();
	if ((rect.Width() != m_rectPrev.Width()) || (rect.Height() != m_rectPrev.Height())) {
		// AύX
		rectTemp = m_rectEnvEdit;	// ϐ
		rectTemp.right += nDiff;
		rectTemp.bottom += nDiffH;
		GetDlgItem(IDC_ENVEDIT)->MoveWindow(&rectTemp);
		// ꏊ
		rectTemp = m_rectOkButton;	// OK
		rectTemp.left += nDiff;
		rectTemp.right += nDiff;
		rectTemp.top += nDiffH;
		rectTemp.bottom += nDiffH;
		GetDlgItem(IDOK)->MoveWindow(&rectTemp);
		rectTemp = m_rectCancelButton;	// LZ
		rectTemp.left += nDiff;
		rectTemp.right += nDiff;
		rectTemp.top += nDiffH;
		rectTemp.bottom += nDiffH;
		GetDlgItem(IDCANCEL)->MoveWindow(&rectTemp);

		// ĕ`
		GetDlgItem(IDOK)->Invalidate();
		GetDlgItem(IDOK)->UpdateWindow();
		GetDlgItem(IDCANCEL)->Invalidate();
		GetDlgItem(IDCANCEL)->UpdateWindow();
	}

	m_rectPrev = rect;
}

/**
 * R}hACẽZbg
 * R}hACe̓Rs[RXgN^ɂăRs[
 * @param pItem [in] Rs[̃R}hACe
 */
void CCommandDialog::SetCommandItem(CCommandItem* pItem)
{
	ASSERT(m_pItem == NULL);
	m_pItem = new CCommandItem(*pItem);
}

/**
 * ̃NX̒l_CAORg[ɔf
 */
void CCommandDialog::SetDlgValues()
{
	// Window̑傫
	switch (m_pItem->GetShowWindow()) {
		case SW_SHOWMINNOACTIVE:
			m_nShowWindow = 1;
			break;
		case SW_SHOWMAXIMIZED:
			m_nShowWindow = 2;
			break;
		default:
			m_nShowWindow = 0;
			break;
	}

	m_strTitleEdit = m_pItem->GetTitle();	// ^Cg
	m_strLinkEdit = m_pItem->GetLink();	// N
	m_strWorkFolderEdit = m_pItem->GetWorkFolder();	// ƃtH_
	m_strCommentEdit = m_pItem->GetComment();	// Rg
	if (m_pItem->GetEnvLineCount() > 0) {	// ϐ
		m_strEnvEdit = m_pItem->GetEnv(0);
	}
	else {
		m_strEnvEdit = _T("");
	}
	for (int i = 1; i < m_pItem->GetEnvLineCount(); i++) {
		m_strEnvEdit += STR_EOL;
		m_strEnvEdit += m_pItem->GetEnv(i);
	}

	UpdateData(FALSE);	// f
}

/**
 * IDOKnh
 */
void CCommandDialog::OnOK()
{
	UpdateData(TRUE);	// _CAORg[̓͂荞

	switch (m_nShowWindow) {
		case 1:
			m_pItem->SetShowWindow(SW_SHOWMINNOACTIVE);
			break;
		case 2:
			m_pItem->SetShowWindow(SW_SHOWMAXIMIZED);
			break;
		default:
			m_pItem->SetShowWindow(SW_SHOW);
			break;
	}

	CString strCaption, strMsg;
	strCaption.LoadString(IDS_CAPTION);
	// O̓`FbN
	if (m_strTitleEdit.IsEmpty() != FALSE) {
		strMsg.LoadString(STR_INPUTTITLE);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_TITLEEDIT));
		return;
	}
	// N̓`FbN
	if (m_strLinkEdit.IsEmpty() != FALSE) {
		strMsg.LoadString(STR_INPUTLINK);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_LINKEDIT));
		return;
	}
	// N`FbN
	CString str = m_strLinkEdit;
	CCommandItem::GetExecPathName(str);
	if (CCommandItem::IsExecutable(str) == FALSE) {
		strMsg.LoadString(STR_LINKNOTEXECUTABLE);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_LINKEDIT));
		return;
	}

	// ƃtH_̓`FbN
	if (m_strWorkFolderEdit.IsEmpty() != FALSE) {
		strMsg.LoadString(STR_INPUTWORKFOLDER);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_FOLDEREDIT));
		return;
	}
	DWORD dwAttr = ::GetFileAttributes(m_strWorkFolderEdit);
	if ((dwAttr == 0xFFFFFFFF) || ((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == 0)) {
		strMsg.LoadString(STR_INVALIDWORKFOLDER);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_FOLDEREDIT));
		return;
	}

	// ACeɐݒ
	m_pItem->SetTitle(m_strTitleEdit);
	m_pItem->SetLink(m_strLinkEdit);
	m_pItem->SetWorkFolder(m_strWorkFolderEdit);
	m_pItem->SetComment(m_strCommentEdit);

	// ϐ\z
	if (m_pItem->SetEnv(m_strEnvEdit) == FALSE) {
		strMsg.LoadString(IDS_ENVERROR);
		MessageBox(strMsg, strCaption, MB_ICONEXCLAMATION | MB_OK);
		GotoDlgCtrl(GetDlgItem(IDC_ENVEDIT));
		return;
	}
	// ϐ\z
	m_pItem->CreateEnvironment();

	// j[^Cg̍쐬
	m_pItem->CreateMenuTitle();

	CDialog::OnOK();
}

/**
 * R}hACe̎擾
 * (Ă񂾂ACe폜͌Ă񂾑̐ӔC)
 * @return R}hACe
 */
CCommandItem* CCommandDialog::GetCommandItem()
{
	CCommandItem* pItem = m_pItem;
	m_pItem = NULL;	// NULLZbgĐӔCĂ񂾑Ɉڂ
	return pItem;
}

/**
 * IDC_LINKBUTTONnh
 */
void CCommandDialog::OnBnClickedLinkbutton()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CString strPathName, strExeExt;
	CEnvironmentList envList;
	// st@C̊gqϐ擾
	BOOL fSuccess = envList.Initialize(_T("PATHEXT"));
	if (fSuccess != FALSE) {
		if (envList.GetSize() > 0) {
			strPathName = _T("*");
			strPathName += envList.GetItem(0);
			for (int i = 1; i < envList.GetSize(); i++){
				strPathName += _T(";*");
				strPathName += envList.GetItem(i);
			}
			strExeExt.Format(IDS_EXEPATH, strPathName);
		}
		else {
			fSuccess = FALSE;
		}
	}
	if (fSuccess == FALSE) {	// ŝňʓIȂ̂
		strExeExt.Format(IDS_EXEPATH, _T("*.COM;*.EXE;*.BAT;*.CMD;*.VBS;*.VBE;*.JS;*.JSE;*.WSF;*.WSH"));
	}

	// t@CJ_CAO
	GetDlgItem(IDC_LINKEDIT)->GetWindowText(strPathName);
	CCommandItem::GetExecPathName(strPathName);
	// t@CT
	DWORD dwAttr = ::GetFileAttributes(strPathName);
	if ((dwAttr & FILE_ATTRIBUTE_DIRECTORY) != 0) {	// ݂ȂA邢̓fBNg
		TCHAR szExec[PATH_BUFF_SIZE];
		szExec[0] = 0;
		::FindExecutable(strPathName, NULL, szExec);
		if (szExec[0] != 0) {
			strPathName = szExec;
		}
	}
	CFileDialog dlg(TRUE, NULL, strPathName, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, strExeExt);
	CString str;
	str.LoadString(IDS_FINDLINK);
	dlg.m_ofn.lpstrTitle = str;
	if (dlg.DoModal() == IDOK) {
		CString strNewPath = dlg.GetPathName();
		if (strNewPath.Find(_T(' ')) > -1) {	// pXɔpXy[XꍇNEH[gň͂
			strNewPath = _T("\"") + strNewPath + _T("\"");
		}
		GetDlgItem(IDC_LINKEDIT)->SetWindowText(strNewPath);
		// t@CύXĂACRƃfBNgύX
		if (strNewPath != m_strLinkEdit) {
			OnEnKillfocusLinkedit();
		}
	}
}

/**
 * IDC_ICONBUTTONnh
 */
void CCommandDialog::OnBnClickedIconbutton()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CIconDialog dlg;
	dlg.SetPathName(m_pItem->GetIconFileName());
	dlg.SetIconIndex(m_pItem->GetIconIndex());
	if (dlg.DoModal() == IDOK) {
		m_pItem->SetIconFileName(dlg.GetPathName());
		m_pItem->SetIconIndex(dlg.GetIconIndex());
		m_pItem->CreateHicon();
		// ACRύX
		if (m_hLargeIcon != NULL) {
			::DestroyIcon(m_hLargeIcon);
		}
		m_hLargeIcon = m_pItem->ExtractLargeIcon();
		((CStatic*) GetDlgItem(IDC_CMDICON))->SetIcon(m_hLargeIcon);
	}
}

/**
 * IDC_LINKEDITtH[JX
 */
void CCommandDialog::OnEnKillfocusLinkedit()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CString str;
	GetDlgItem(IDC_LINKEDIT)->GetWindowText(str);
	CCommandItem::GetExecPathName(str);	// V͂擾
	CString str2 = m_strLinkEdit;
	CCommandItem::GetExecPathName(str2);	// ݂̓͂擾
	if (str.CompareNoCase(str2) != 0) {
		// t@C݂fBNgłȂƂmF
		TCHAR szExec[PATH_BUFF_SIZE];
		TCHAR szLongPath[PATH_BUFF_SIZE];
		szExec[0] = 0;
		::FindExecutable(str, NULL, szExec);
		if (szExec[0] != 0) {
			str = szExec;
			int nPos = str.ReverseFind(_T('\\'));
			str2 = str.Left(nPos);
			CRienbuApp::GetLongPathName(str2, szLongPath, MAX_PATH);
			// ƃtH_ύX
			m_pItem->SetWorkFolder(szLongPath);
			GetDlgItem(IDC_FOLDEREDIT)->SetWindowText(szLongPath);
			// ACRύX
			m_pItem->SetIconFileName(str);
			m_pItem->SetIconIndex(0);
			m_pItem->CreateHicon();
			if (m_hLargeIcon != NULL) {
				::DestroyIcon(m_hLargeIcon);
			}
			m_hLargeIcon = m_pItem->ExtractLargeIcon();
			((CStatic*) GetDlgItem(IDC_CMDICON))->SetIcon(m_hLargeIcon);
		}
		else {
			GetDlgItem(IDC_LINKEDIT)->GetWindowText(str);
			// NEH[gň͂čĒ
			str = _T('\"') + str + _T('\"');
			CString strQuote = str;
			CCommandItem::GetExecPathName(str);
			szExec[0] = 0;
			::FindExecutable(str, NULL, szExec);
			if (szExec[0] != 0) {
				str = szExec;
				int nPos = str.ReverseFind(_T('\\'));
				str2 = str.Left(nPos);
				CRienbuApp::GetLongPathName(str2, szLongPath, MAX_PATH);
				// ƃtH_ύX
				m_pItem->SetWorkFolder(szLongPath);
				GetDlgItem(IDC_FOLDEREDIT)->SetWindowText(szLongPath);
				// ACRύX
				m_pItem->SetIconFileName(str);
				m_pItem->SetIconIndex(0);
				m_pItem->CreateHicon();
				if (m_hLargeIcon != NULL) {
					::DestroyIcon(m_hLargeIcon);
				}
				m_hLargeIcon = m_pItem->ExtractLargeIcon();
				((CStatic*) GetDlgItem(IDC_CMDICON))->SetIcon(m_hLargeIcon);
				// Rg[̕ύX
				GetDlgItem(IDC_LINKEDIT)->SetWindowText(strQuote);
			}
		}
	}
}

/**
 * IDC_WKFOLDERBUTTONnh
 */
void CCommandDialog::OnBnClickedWkfolderbutton()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CString strPathName;
	CFolderDialog dlg(this);
	GetDlgItem(IDC_FOLDEREDIT)->GetWindowText(strPathName);
	if (strPathName.IsEmpty() != FALSE) {
		GetDlgItem(IDC_LINKEDIT)->GetWindowText(strPathName);
		if (strPathName.IsEmpty() != FALSE) {
			// Program Files擾
			CRienbuApp::GetSpecialFolder(strPathName.GetBuffer(PATH_BUFF_SIZE), CSIDL_PROGRAM_FILES);
			strPathName.ReleaseBuffer();
		}
		else {
			CCommandItem::GetExecPathName(strPathName);
		}
	}

	// _CAO\
	dlg.SetPathName(strPathName);
	if (dlg.DoModal() == IDOK) {
		GetDlgItem(IDC_FOLDEREDIT)->SetWindowText(dlg.GetPathName());
	}
}
