//-----------------------------------------------------------------------------
// Desc:	Xgr[wb_
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B

// ȉ̃TCg̃R[hQlɍ쐬܂B
// http://www.codeguru.com/

//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "SortHeaderCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSortHeaderCtrl

//
// RXgN^
// CSortHeaderCtrl::CSortHeaderCtrl
// type : public
//
CSortHeaderCtrl::CSortHeaderCtrl()
{
	m_iSpacing = 6;
	m_iSortColumn = -1;
	m_bSortAscending = TRUE;
	m_nClickFlags = 0;
	m_iHotIndex = -1;
	m_cr3DHighLight = ::GetSysColor(COLOR_3DHIGHLIGHT);
	m_cr3DShadow = ::GetSysColor(COLOR_3DSHADOW);
	m_cr3DFace = ::GetSysColor(COLOR_3DFACE);
	m_crText = ::GetSysColor(COLOR_BTNTEXT);

	m_sizeArrow.cx = 8;
	m_sizeArrow.cy = 8;
	m_sizeImage.cx = 0;
	m_sizeImage.cy = 0;

	m_arrayHdrItemEx.SetSize(0, 8);
}

//
// fXgN^
// CSortHeaderCtrl::~CSortHeaderCtrl
// type : public, virtual
//
CSortHeaderCtrl::~CSortHeaderCtrl()
{
}

BEGIN_MESSAGE_MAP(CSortHeaderCtrl, CHeaderCtrl)
	//{{AFX_MSG_MAP(CSortHeaderCtrl)
	ON_WM_PAINT()
	ON_WM_SYSCOLORCHANGE()
	ON_WM_NCHITTEST()
	ON_WM_DRAWITEM()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_MESSAGE(HDM_SETIMAGELIST, OnSetImageList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSortHeaderCtrl bZ[W nh

//
// WM_PAINTnh
// CSortHeaderCtrl::OnPaint
// type : protected
//
void CSortHeaderCtrl::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	DrawCtrl(&dc);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// `pbZ[WƂ CHeaderCtrl::OnPaint() ĂяoĂ͂܂
}

//
// WM_SYSCOLORCHANGEnh
// CSortHeaderCtrl::OnSysColorChange
// type : protected
//
void CSortHeaderCtrl::OnSysColorChange() 
{
	CHeaderCtrl::OnSysColorChange();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_cr3DHighLight = ::GetSysColor(COLOR_3DHIGHLIGHT);
	m_cr3DShadow = ::GetSysColor(COLOR_3DSHADOW);
	m_cr3DFace = ::GetSysColor(COLOR_3DFACE);
	m_crText = ::GetSysColor(COLOR_BTNTEXT);
}

//
// Rg[Ŝ̕`
// CSortHeaderCtrl::DrawCtrl
// type : protected
//
void CSortHeaderCtrl::DrawCtrl(CDC* pDC)
{
	CRect rectClip;
	if (pDC->GetClipBox(&rectClip) == ERROR) {
		return;
	}

	CRect rectClient, rectItem;
	GetClientRect(&rectClient);

    pDC->FillSolidRect(rectClip, m_cr3DFace);

	int iItems = GetItemCount();

	CPen penHighLight(PS_SOLID, 1, m_cr3DHighLight);
	CPen penShadow(PS_SOLID, 1, m_cr3DShadow);
	CPen* pPen = pDC->GetCurrentPen();

	CFont* pFont = pDC->SelectObject(GetFont());

	pDC->SetBkColor(m_cr3DFace);
	pDC->SetTextColor(m_crText);

	int iWidth = 0;

	for (int i = 0; i < iItems; i++) {
		int iItem = OrderToIndex(i);

		TCHAR szText[80];

		HDITEM hditem;
		hditem.mask = HDI_WIDTH | HDI_FORMAT | HDI_TEXT | HDI_IMAGE | HDI_BITMAP;
		hditem.pszText = szText;
		hditem.cchTextMax = sizeof(szText);
		VERIFY(GetItem(iItem, &hditem));

		VERIFY(GetItemRect(iItem, rectItem));

		if (rectItem.right >= rectClip.left || rectItem.left <= rectClip.right) {
			if (hditem.fmt&HDF_OWNERDRAW) {
				DRAWITEMSTRUCT disItem;
				disItem.CtlType = ODT_BUTTON;
				disItem.CtlID = GetDlgCtrlID();
				disItem.itemID = iItem;
				disItem.itemAction = ODA_DRAWENTIRE;
				disItem.itemState = 0;
				disItem.hwndItem = m_hWnd;
				disItem.hDC = pDC->m_hDC;
				disItem.rcItem = rectItem;
				disItem.itemData = 0;

				DrawItem(&disItem);
			}
			else {
				rectItem.DeflateRect(m_iSpacing, 0);
				DrawItem(pDC, rectItem, &hditem, iItem == m_iSortColumn, m_bSortAscending);
				rectItem.InflateRect(m_iSpacing, 0);
			}

			if (i < iItems-1) {
				pDC->SelectObject(&penShadow);
				pDC->MoveTo(rectItem.right - 1, rectItem.top + 2);
				pDC->LineTo(rectItem.right - 1, rectItem.bottom - 2);

				pDC->SelectObject(&penHighLight);
				pDC->MoveTo(rectItem.right, rectItem.top + 2);
				pDC->LineTo(rectItem.right, rectItem.bottom - 2);
			}
		}

		iWidth += hditem.cxy;
	}

	if(iWidth > 0)
	{
		rectClient.right = rectClient.left + iWidth;
		pDC->Draw3dRect(rectClient, m_cr3DHighLight, m_cr3DShadow);
	}

	pDC->SelectObject(pFont);
	pDC->SelectObject(pPen);

	penHighLight.DeleteObject();
	penShadow.DeleteObject();
}

//
// WM_NCHITTESTnh
// CSortHeaderCtrl::OnNcHitTest
// type : protected
//
//UINT CSortHeaderCtrl::OnNcHitTest(CPoint point) 
LRESULT CSortHeaderCtrl::OnNcHitTest(CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_hdhtiHotItem.pt = point;
	ScreenToClient(&m_hdhtiHotItem.pt);

	return CHeaderCtrl::OnNcHitTest(point);
}

//
// ACe̕`(1)
// CSortHeaderCtrl::DrawItem
// ͎gpȂ
// type : protected, virtual
//
void CSortHeaderCtrl::DrawItem(LPDRAWITEMSTRUCT)
{
	ASSERT(FALSE);  // must override for self draw header controls
}

//
// ACe̕`(2)
// CSortHeaderCtrl::DrawItem
// gp
// type : protected, virtual
//
void CSortHeaderCtrl::DrawItem(CDC* pDC, CRect rect, LPHDITEM lphdi, BOOL bSort, BOOL bSortAscending)
{
	ASSERT(lphdi->mask&HDI_FORMAT);

	int iWidth = 0;
	BOOL fPush = FALSE;
	if (m_nClickFlags & MK_LBUTTON) {
		if (rect.PtInRect(m_ptClickPoint) != FALSE) {
			fPush = TRUE;
		}
	}

	switch(lphdi->fmt&HDF_JUSTIFYMASK) {
	case HDF_LEFT:
		rect.right -= bSort ? m_iSpacing + m_sizeArrow.cx : 0;
		rect.left += (iWidth = DrawText(pDC, rect, lphdi, fPush)) ? iWidth + m_iSpacing : 0;
		if (bSort) {
			rect.right += m_iSpacing + m_sizeArrow.cx;
			rect.left += DrawArrow(pDC, rect, bSortAscending, lphdi, FALSE, fPush) + m_iSpacing;
		}
		break;

	case HDF_CENTER:
		if (bSort) {
			rect.left -= m_iSpacing + m_sizeArrow.cx;
			rect.right -= DrawArrow(pDC, rect, bSortAscending, lphdi, TRUE, fPush) + 2 * m_iSpacing;
		}
		DrawText(pDC, rect, lphdi, fPush);
		break;

	case HDF_RIGHT:
		if (bSort) {
			rect.left -= (lphdi->fmt & HDF_BITMAP_ON_RIGHT) ? m_iSpacing + m_sizeArrow.cx : 0;
			rect.right -= DrawArrow(pDC, rect, bSortAscending, lphdi, TRUE, fPush) + 2 * m_iSpacing;
		}
		DrawText(pDC, rect, lphdi, fPush);
		break;
	}
}

//
// eLXg̕`
// CSortHeaderCtrl::DrawText
// eLXghbgŕԂ
// type : protected
//
int CSortHeaderCtrl::DrawText(CDC* pDC, CRect rect, LPHDITEM lphdi, BOOL fPush)
{
	CSize size;

	if (fPush != FALSE) {
		rect.left++;
		rect.top++;
		rect.right++;
		rect.bottom++;
	}
	if (rect.Width() > 0 && lphdi->mask & HDI_TEXT && lphdi->fmt & HDF_STRING) {
		size = pDC->GetTextExtent(lphdi->pszText);

		switch(lphdi->fmt&HDF_JUSTIFYMASK) {
		case HDF_LEFT:
		case HDF_LEFT | HDF_RTLREADING:
			pDC->DrawText(lphdi->pszText, -1, rect, DT_LEFT | DT_END_ELLIPSIS | DT_SINGLELINE | DT_VCENTER);
			break;
		case HDF_CENTER:
		case HDF_CENTER | HDF_RTLREADING:
			pDC->DrawText(lphdi->pszText, -1, rect, DT_CENTER | DT_END_ELLIPSIS | DT_SINGLELINE | DT_VCENTER);
			break;
		case HDF_RIGHT:
		case HDF_RIGHT | HDF_RTLREADING:
			pDC->DrawText(lphdi->pszText, -1, rect, DT_RIGHT | DT_END_ELLIPSIS | DT_SINGLELINE | DT_VCENTER);
			break;
		}
	}
	if (fPush != FALSE) {
		rect.left--;
		rect.top--;
		rect.right--;
		rect.bottom--;
	}

	size.cx = rect.Width() > size.cx ? size.cx : rect.Width();
	return size.cx > 0 ? size.cx : 0;
}

//
// \[gڈ̕`
// CSortHeaderCtrl::DrawArrow
// 󕝂hbgŕԂ
// type : protected
//
int CSortHeaderCtrl::DrawArrow(CDC* pDC, CRect rect, BOOL bSortAscending, LPHDITEM lphdi, BOOL bRight, BOOL fPush)
{
	CImageList* pImageList = GetImageList();
	int iWidth = 0;
	int nImage;

	if (bSortAscending)	{
		nImage = 1;
	}
	else {
		nImage = 0;
	}
	ASSERT(pImageList);
	ASSERT(lphdi->iImage >= 0 && lphdi->iImage < pImageList->GetImageCount());

	if (rect.Width() > 0) {
		POINT point;

		point.y = rect.CenterPoint().y - (m_sizeImage.cy >> 1);

		if (bRight) {
			point.x = rect.right - m_sizeImage.cx;
		}
		else {
			point.x = rect.left;
		}
		if (fPush) {
			point.x++;
			point.y++;
		}

		SIZE size;
		size.cx = rect.Width() < m_sizeImage.cx ? rect.Width() : m_sizeImage.cx;
		size.cy = m_sizeImage.cy;
		pImageList->DrawIndirect(pDC, nImage, point, size, CPoint(0, 0));

		iWidth = m_sizeImage.cx;
	}

	return iWidth;
}

//
// ACe̎擾
// CSortHeaderCtrl::GetItemEx
// ̏ꍇOȊOAs̏ꍇO
// type : public
//
BOOL CSortHeaderCtrl::GetItemEx(int iPos, HDITEMEX* phditemex) const
{
	if (iPos >= m_arrayHdrItemEx.GetSize()) {
		return FALSE;
	}

	*phditemex = m_arrayHdrItemEx[iPos];
	return TRUE;
}

//
// \[gJ̐ݒ
// CSortHeaderCtrl::SetSortColumn
// type : public
//
void CSortHeaderCtrl::SetSortColumn(int iPos, BOOL bSortAscending)
{
	ASSERT(iPos < GetItemCount());

	m_bSortAscending = bSortAscending;
	m_iSortColumn = iPos;
	Invalidate();
}

//
// \[gJ̎擾
// CSortHeaderCtrl::GetSortColumn
// \[gJ̃CfbNX
// type : public
//
int CSortHeaderCtrl::GetSortColumn(BOOL* pbSortAscending)
{
	if (pbSortAscending) {
		*pbSortAscending = m_bSortAscending;
	}

	return m_iSortColumn;
}

//
// WM_LBUTTONDOWNnh
// CSortHeaderCtrl::OnLButtonDown
// type : protected
//
void CSortHeaderCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_nClickFlags = nFlags;
	m_ptClickPoint = point;
	CHeaderCtrl::OnLButtonDown(nFlags, point);
}

//
// WM_LBUTTONUPnh
// CSortHeaderCtrl::OnLButtonDown
// type : protected
//
void CSortHeaderCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_nClickFlags = 0;
	m_ptClickPoint = point;
	CHeaderCtrl::OnMButtonUp(nFlags, point);
}

//
// tH[JXXg̒ʒm
// CSortHeaderCtrl::KillFocus
// type : public
//
void CSortHeaderCtrl::KillFocus()
{
	m_nClickFlags = 0;
}

//
// C[WXgZbgꂽ
// CSortHeaderCtrl::OnSetImageList
// O
// type : protected
//
LRESULT CSortHeaderCtrl::OnSetImageList(WPARAM wParam, LPARAM lParam)
{
	CImageList* pImageList;
	pImageList = CImageList::FromHandle((HIMAGELIST) lParam);

	IMAGEINFO info;
	if (pImageList->GetImageInfo(0, &info)) {
		m_sizeImage.cx = info.rcImage.right - info.rcImage.left;
		m_sizeImage.cy = info.rcImage.bottom - info.rcImage.top;
	}

	return Default();
}
