//-----------------------------------------------------------------------------
// Desc:	R}hACe
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Rienbu.h"
#include "CommandItem.h"
#include "8riStringFile.h"

#define KEY_TPLT					_T("%s%d")

// CCommandItem

/**
 * WXgN^
 */
CCommandItem::CCommandItem()
{
	m_wShowWindow = SW_SHOW;
	m_hIcon = NULL;
	m_nIconIndex = 0;
	m_pEnvSet = NULL;
	// j[\
	m_lpszMenuDisp = NULL;
	m_nAcc = -1;
	m_nAccKey = 0;
}

/**
 * Rs[RXgN^
 * @param item [in] Rs[
 */
CCommandItem::CCommandItem(CCommandItem& item)
{
	// ACR
	m_strIconFile = item.m_strIconFile;
	m_nIconIndex = item.m_nIconIndex;
	m_hIcon = NULL;
	CreateHicon();	// ACR쐬

	// ɃRs[
	m_strTitle = item.m_strTitle;
	m_strLink = item.m_strLink;
	m_strWorkFolder = item.m_strWorkFolder;
	m_wShowWindow = item.m_wShowWindow;
	m_strComment = item.m_strComment;

	// ϐ
	m_arstrEnv.RemoveAll();
	for (int i = 0; i < item.GetEnvLineCount(); i++) {
		m_arstrEnv.Add(item.GetEnv(i));
	}
	m_arstrEnv.FreeExtra();
	m_pEnvSet = NULL;
	// j[\
	m_lpszMenuDisp = NULL;
	m_nAcc = -1;
	m_nAccKey = 0;
	CreateMenuTitle();

	m_env.Empty();
	// ϐ\z
	CString str;
	for (INT_PTR ip = 0; ip < m_arstrEnv.GetSize(); ip++) {
		str = m_arstrEnv.GetAt(ip);
		str.Trim();
		if (str.IsEmpty() == FALSE) {
			m_env.Add(str);
		}
	}
}

/**
 * fXgN^
 */
CCommandItem::~CCommandItem()
{
	// ACR폜
	if (m_hIcon != NULL) {
		::DestroyIcon(m_hIcon);
	}

	// ϐZbg폜
	delete m_pEnvSet;
	// j[\폜
	delete[] m_lpszMenuDisp;
}

// CCommandItem o֐
/**
 * ACRnh̍쐬
 */
void CCommandItem::CreateHicon()
{
	if (m_hIcon != NULL) {
		::DestroyIcon(m_hIcon);
		m_hIcon = NULL;
	}

	UINT nIcons = ::ExtractIconEx(m_strIconFile, m_nIconIndex, NULL, &m_hIcon, 1);
	if (nIcons == 0) {
		CreateDefaultIcon();
	}
}

/**
 * ftHgACRnh̍쐬
 */
void CCommandItem::CreateDefaultIcon()
{
	if (m_hIcon != NULL) {
		::DestroyIcon(m_hIcon);
		m_hIcon = NULL;
	}

	// ̃AvP[V
	TCHAR szPath[PATH_BUFF_SIZE];
	::GetModuleFileName(NULL, szPath, MAX_PATH);
	m_nIconIndex = 1;
	m_strIconFile = szPath;
	::ExtractIconEx(m_strIconFile, m_nIconIndex, NULL, &m_hIcon, 1);
}

/**
 * ϐ̐ݒ
 * @param lpszEnv [in] 쐬ϐS
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::SetEnv(LPCTSTR lpszEnv)
{
	m_arstrEnv.RemoveAll();
	LPCTSTR lpszTemp = lpszEnv;
	LPCTSTR lpszCRLF;
	int nLen;
	CString str;
	while (TRUE) {
		lpszCRLF = ::_tcsstr(lpszTemp, STR_EOL);
		if (lpszCRLF == NULL) {
			m_arstrEnv.Add(lpszTemp);
			break;	// ŏIsɗ̂Ń[v甲
		}
		else {
			nLen = (int) (lpszCRLF - lpszTemp);
			if (nLen == 0) {	// s
				m_arstrEnv.Add(_T(""));
			}
			else {
				str = lpszTemp;
				m_arstrEnv.Add(str.Left(nLen));
			}
			lpszTemp = lpszCRLF;
			lpszTemp += ::lstrlen(STR_EOL);
		}
	}
	m_arstrEnv.FreeExtra();

	BOOL bRet = TRUE;
	// sɍ쐬ϐIuWFNg쐬
	m_env.Empty();	// ϐUɂ
	for (INT_PTR i = 0; i < m_arstrEnv.GetSize(); i++) {
		str = m_arstrEnv.GetAt(i);
		str.Trim();	// ÕXy[X폜
		if (str.IsEmpty() == FALSE) {
			if (m_env.Add(str) == FALSE) {
				bRet = FALSE;
				break;	// I
			}
		}
	}

	return bRet;
}

/**
 * ϐs̒ǉ
 * @param lpszEnv [in] ϐs
 */
void CCommandItem::AddEnv(LPCTSTR lpszEnv)
{
	m_arstrEnv.Add(lpszEnv);
}

/**
 * t@Cւ̂̓ǂݍ
 * pFile [in] ݐt@Cnh
 * nIndex [in] ACẽCfbNX
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::Write(FILE* pFile, int nIndex)
{
	size_t st;
	TCHAR szBuff[128];
	int nEOL = ::lstrlen(STR_EOL);

	// ACeJn
	st = CCommandItem::WriteLine(ITEM_START, pFile);
	if (st != ((::lstrlen(ITEM_START) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// ACẽCfbNX
	::wsprintf(szBuff, KEY_TPLT, INDEX_KEY, nIndex);
	st = CCommandItem::WriteLine(szBuff, pFile);
	if (st != ((::lstrlen(szBuff) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// ACRt@C
	st = CCommandItem::WriteKey(ICOFILE_KEY, pFile);
	if (st != (::lstrlen(ICOFILE_KEY) * sizeof(TCHAR))) {
		return FALSE;
	}
	st = CCommandItem::WriteLine(GetIconFileName(), pFile);
	if (st != ((::lstrlen(GetIconFileName()) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// ACRCfbNX
	::wsprintf(szBuff, KEY_TPLT, ICOIDX_KEY, GetIconIndex());
	st = CCommandItem::WriteLine(szBuff, pFile);
	if (st != ((::lstrlen(szBuff) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// O
	st = CCommandItem::WriteKey(TITLE_KEY, pFile);
	if (st != (::lstrlen(TITLE_KEY) * sizeof(TCHAR))) {
		return FALSE;
	}
	st = CCommandItem::WriteLine(GetTitle(), pFile);
	if (st != ((::lstrlen(GetTitle()) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// N
	st = CCommandItem::WriteKey(LINK_KEY, pFile);
	if (st != (::lstrlen(LINK_KEY) * sizeof(TCHAR))) {
		return FALSE;
	}
	st = CCommandItem::WriteLine(GetLink(), pFile);
	if (st != ((::lstrlen(GetLink()) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// ƃtH_
	st = CCommandItem::WriteKey(WKFOLD_KEY, pFile);
	if (st != (::lstrlen(WKFOLD_KEY) * sizeof(TCHAR))) {
		return FALSE;
	}
	st = CCommandItem::WriteLine(GetWorkFolder(), pFile);
	if (st != ((::lstrlen(GetWorkFolder()) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// EBhȆ傫
	::wsprintf(szBuff, KEY_TPLT, SW_KEY, (int) GetShowWindow());
	st = CCommandItem::WriteLine(szBuff, pFile);
	if (st != ((::lstrlen(szBuff) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// Rg
	st = CCommandItem::WriteKey(COMMENT_KEY, pFile);
	if (st != (::lstrlen(COMMENT_KEY) * sizeof(TCHAR))) {
		return FALSE;
	}
	st = CCommandItem::WriteLine(GetComment(), pFile);
	if (st != ((::lstrlen(GetComment()) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// ϐ
	if (WriteEnv(pFile) == FALSE) {
		return FALSE;
	}

	// ACeI
	st = CCommandItem::WriteLine(ITEM_END, pFile);
	if (st != ((::lstrlen(ITEM_END) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	return TRUE;
}

/**
 * t@C֊ϐ̏
 * @param lpszLine [in] ލs
 * pFile [in] ݐt@Cnh
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::WriteEnv(FILE* pFile)
{
	size_t st;
	int nEOL = ::lstrlen(STR_EOL);

	// ϐJn
	st = CCommandItem::WriteLine(ENV_START, pFile);
	if (st != ((::lstrlen(ENV_START) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	// s
	for (int i = 0; i < GetEnvLineCount(); i++) {
		st = CCommandItem::WriteLine(GetEnv(i), pFile);
		if (st != ((::lstrlen(GetEnv(i)) + nEOL) * sizeof(TCHAR))) {
			return FALSE;
		}
	}

	// ϐI
	st = CCommandItem::WriteLine(ENV_END, pFile);
	if (st != ((::lstrlen(ENV_END) + nEOL) * sizeof(TCHAR))) {
		return FALSE;
	}

	return TRUE;
}

/**
 * 1so
 * @param lpszLine [in] ލs
 * @param pFile [in] ݐt@Cnh
 * @return ܂ꂽTCY
 */
size_t CCommandItem::WriteLine(LPCTSTR lpszLine, FILE* pFile)
{
	size_t st = 0;
	int nSize = ::lstrlen(lpszLine);
	if (nSize > 0) {
		st = ::fwrite(lpszLine, 1, nSize * sizeof(TCHAR), pFile);
	}
	st += ::fwrite(STR_EOL, 1, ::lstrlen(STR_EOL) * sizeof(TCHAR), pFile);
	return st;
}

/**
 * L[o
 * @param lpszLine [in] ލs
 * @param pFile [in] ݐt@Cnh
 * @return ܂ꂽTCY
 */
size_t CCommandItem::WriteKey(LPCTSTR lpszLine, FILE* pFile)
{
	size_t st = 0;
	int nSize = ::lstrlen(lpszLine);
	if (nSize > 0) {
		st = ::fwrite(lpszLine, 1, nSize * sizeof(TCHAR), pFile);
	}
	return st;
}

/**
 * t@C̓ǂݍ
 * @param pFile [in] ݒt@C
 * @return 쐬ꂽR}hACe
 */
CCommandItem* CCommandItem::Read(C8riStringFile* pFile)
{
	LPCTSTR lpszLine = pFile->Read();
	if (lpszLine == NULL) {
		return NULL;	// I
	}
	BOOL fItem = TRUE;
	// ZNV̊Jn𒲂ׂ
	while (::lstrcmp(lpszLine, ITEM_START) != 0) {
		lpszLine = pFile->Read();
		if (lpszLine == NULL) {
			fItem = FALSE;
			break;
		}
	}
	if (fItem == FALSE) {
		return NULL;
	}

	// ZNV̏I܂œǂ
	BOOL fSuccess = TRUE;	// Esʎq
	CCommandItem* pItem = new CCommandItem;
	while (::lstrcmp(lpszLine, ITEM_END) != 0) {
		// INDEX=͓ǂݔ΂
		if (::_tcsncmp(ICOFILE_KEY, lpszLine, ::lstrlen(ICOFILE_KEY)) == 0) {
			lpszLine += ::lstrlen(ICOFILE_KEY);	// ACRt@C
			pItem->SetIconFileName(lpszLine);
		}
		else if (::_tcsncmp(ICOIDX_KEY, lpszLine, ::lstrlen(ICOIDX_KEY)) == 0) {
			lpszLine += ::lstrlen(ICOIDX_KEY);	// ACRCfbNX
			pItem->SetIconIndex(::_ttoi(lpszLine));
		}
		else if (::_tcsncmp(TITLE_KEY, lpszLine, ::lstrlen(TITLE_KEY)) == 0) {
			lpszLine += ::lstrlen(TITLE_KEY);	// O
			pItem->SetTitle(lpszLine);
		}
		else if (::_tcsncmp(LINK_KEY, lpszLine, ::lstrlen(LINK_KEY)) == 0) {
			lpszLine += ::lstrlen(LINK_KEY);	// N
			pItem->SetLink(lpszLine);
		}
		else if (::_tcsncmp(WKFOLD_KEY, lpszLine, ::lstrlen(WKFOLD_KEY)) == 0) {
			lpszLine += ::lstrlen(WKFOLD_KEY);	// ƃtH_
			pItem->SetWorkFolder(lpszLine);
		}
		else if (::_tcsncmp(SW_KEY, lpszLine, ::lstrlen(SW_KEY)) == 0) {
			lpszLine += ::lstrlen(SW_KEY);	// EBhȆ傫
			pItem->SetShowWindow((WORD) ::_ttoi(lpszLine));
		}
		else if (::_tcsncmp(COMMENT_KEY, lpszLine, ::lstrlen(COMMENT_KEY)) == 0) {
			lpszLine += ::lstrlen(COMMENT_KEY);	// Rg
			pItem->SetComment(lpszLine);
		}
		else if (::lstrcmp(ENV_START, lpszLine) == 0) {
			fSuccess = CCommandItem::ReadEnv(pFile, pItem);	// ϐǂ
			if (fSuccess == FALSE) {
				break;
			}
		}

		// ̍sǂ
		lpszLine = pFile->Read();
		if (lpszLine == NULL) {
			fSuccess = FALSE;	// Ō܂œǂ܂͖͂
		}
	}
	// sĂꍇ
	if (fSuccess == FALSE) {
		delete pItem;
		return FALSE;
	}

	// ϐ\z
	CString str;
	for (INT_PTR ip = 0; ip < pItem->m_arstrEnv.GetSize(); ip++) {
		str = pItem->m_arstrEnv.GetAt(ip);
		str.Trim();
		if (str.IsEmpty() == FALSE) {
			pItem->m_env.Add(str);
		}
	}
	// ACR̍쐬
	pItem->CreateHicon();
	// j[p^Cg̍쐬
	pItem->CreateMenuTitle();
	// ϐ\z
	pItem->CreateEnvironment();

	return pItem;
}

/**
 * t@C̓ǂݍ
 * @param pFile ݒ肪܂ꂽt@C
 * @param pItem R}hACe
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::ReadEnv(C8riStringFile* pFile, CCommandItem* pItem)
{
	LPCTSTR lpszLine = pFile->Read();
	while (::lstrcmp(lpszLine, ENV_END) != 0) {
		pItem->AddEnv(lpszLine);
		lpszLine = pFile->Read();
		if (lpszLine == NULL) {
			return FALSE;
		}
	}
	return TRUE;
}

/**
 * sIy[^
 * @param item rΏۃACe
 * @return IuWFNgꍇ0AႤꍇ0ȊO
 */
BOOL CCommandItem::operator!=(const CCommandItem& item)
{
	// 
	if (m_strIconFile.CompareNoCase(item.m_strIconFile) != 0) {
		return TRUE;
	}
	if (m_nIconIndex != item.m_nIconIndex) {
		return TRUE;
	}
	if (m_strTitle != item.m_strTitle) {
		return TRUE;
	}
	if (m_strLink != item.m_strLink) {
		return TRUE;
	}
	if (m_strIconFile.CompareNoCase(item.m_strWorkFolder) != 0) {
		return TRUE;
	}
	if (m_wShowWindow != item.m_wShowWindow) {
		return TRUE;
	}
	if (m_strComment != item.m_strComment) {
		return TRUE;
	}
	if (m_arstrEnv.GetSize() != item.m_arstrEnv.GetSize()) {
		return TRUE;
	}
	for (INT_PTR i = 0; i < m_arstrEnv.GetSize(); i++) {
		if (m_arstrEnv.GetAt(i) != item.m_arstrEnv.GetAt(i)) {
			return TRUE;
		}
	}

	return FALSE;
}

/**
 * Iy[^
 * @param item rΏۃACe
 * @return IuWFNgꍇ0ȊOAႤꍇ0
 */
BOOL CCommandItem::operator==(const CCommandItem& item)
{
	BOOL fRet = ((*this) != item);
	return ((fRet == FALSE) ? TRUE : FALSE);
}

/**
 * j[\̍쐬
 */
void CCommandItem::CreateMenuTitle()
{
	delete[] m_lpszMenuDisp;
	m_nAcc = -1;
	m_nAccKey = 0;

	int nLen = ::lstrlen(GetTitle()) + 1;
	m_lpszMenuDisp = new TCHAR[nLen];
	int nAmp = m_strTitle.Find(_T('&'));
	if ((nAmp + 1) == m_strTitle.GetLength()) {
		nAmp = -1;	// Ō̕ApTh̏ꍇANZ[^w肳ĂȂ̂ƌȂ
	}
	if (nAmp < 0) {	// ApTh
		::lstrcpy(m_lpszMenuDisp, GetTitle());
	}
	else {	// ApThL
		m_nAcc = nAmp;
		::lstrcpy(m_lpszMenuDisp, m_strTitle.Left(nAmp));
		::lstrcat(m_lpszMenuDisp, m_strTitle.Right(m_strTitle.GetLength() - nAmp - 1));

		// ̎̕擾
		nAmp++;
		TCHAR c = m_strTitle.GetAt(nAmp);
		c = ::_totupper(c);	// 啶ɕϊ
		m_nAccKey = (UINT) c;
	}
}

/**
 * Wu̎s
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::Exec()
{
	// Vϐ̎擾
	LPBYTE lpszNewEnv = m_env.GetNewEnvironment();

	// R}h̎s
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	::ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	::ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.lpTitle = (LPTSTR) GetMenuTitle();
	si.wShowWindow = GetShowWindow();
	si.dwFlags = STARTF_USESHOWWINDOW;
	BOOL bRet = ::CreateProcess(NULL,
								(LPTSTR) GetLink(),
								NULL,
								NULL,
								FALSE,
#ifdef _UNICODE
								CREATE_NEW_PROCESS_GROUP | NORMAL_PRIORITY_CLASS | CREATE_UNICODE_ENVIRONMENT,
#else
								CREATE_NEW_PROCESS_GROUP | NORMAL_PRIORITY_CLASS,
#endif
								lpszNewEnv,
								GetWorkFolder(),
								&si,
								&pi);

	if (bRet != FALSE) {
		::WaitForInputIdle(pi.hProcess, INFINITE);
		::CloseHandle(pi.hProcess);
		::CloseHandle(pi.hThread);
	}

	// Еt
	delete[] lpszNewEnv;
	return bRet;
}

/**
 * Ǘ҂ƂăWu̎s
 * @param lpszUser [in] [UID
 * @param lpszPassword [in] pX[h
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CCommandItem::ExecAdmin(LPCTSTR lpszUser, LPCTSTR lpszPassword)
{
	// R}h̎s
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	::ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	::ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.lpTitle = (LPTSTR) GetMenuTitle();
	si.wShowWindow = GetShowWindow();
	si.dwFlags = STARTF_USESHOWWINDOW;
	BOOL bRet = ::CreateProcessWithLogonW(lpszUser, NULL, lpszPassword, LOGON_WITH_PROFILE,
		NULL, (LPTSTR) GetLink(),
		CREATE_NEW_PROCESS_GROUP, NULL,
		GetWorkFolder(), &si, &pi);

	if (bRet != FALSE) {
		::WaitForInputIdle(pi.hProcess, INFINITE);
		::CloseHandle(pi.hProcess);
		::CloseHandle(pi.hThread);
	}

	return bRet;
}

/**
 * Nst@C擾
 * @param strPathName [in, out] mȃpX擾obt@
 */
void CCommandItem::GetExecPathName(CString& strPathName)
{
	if (strPathName.GetLength() > 0) {
		int nPos = strPathName.Find(_T('\"'));
		if (nPos < 0) {	// NEH[gȂ
			nPos = strPathName.Find(_T(' '));
			if (nPos > -1) {	// pXy[X
				strPathName = strPathName.Left(nPos);
			}
			return;
		}

		// ŏ̃NEH[g폜
		nPos++;
		strPathName = strPathName.Right(strPathName.GetLength() - nPos);
		nPos = strPathName.Find(_T('\"'));
		if (nPos > -1) {	// ̃NEH[gȍ~폜
			strPathName = strPathName.Left(nPos);
		}
	}
}

/** 
 * s\𒲂ׂ
 * @param strExe
 * @return s\ȏꍇ0ȊOAss\ȏꍇ0
 */
BOOL CCommandItem::IsExecutable(LPCTSTR lpszExe)
{
	BOOL bRet = TRUE;

	// ꎞf

	// st@CT
	TCHAR szExecPath[PATH_BUFF_SIZE];
	szExecPath[0] = 0;
	::FindExecutable(lpszExe, NULL, szExecPath);
	if (szExecPath[0] == 0) {
		bRet = FALSE;
	}

	// ɖ߂

	return bRet;
}
