//-----------------------------------------------------------------------------
// Desc:	R}hACe
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#pragma once

#include "EnvSet.h"

class C8riStringFile;

// CCommandItem R}h ^[Qbg

class CCommandItem : public CObject
{
public:
	/** RXgN^ */
	CCommandItem();
	/** Rs[RXgN^ */
	CCommandItem(CCommandItem& item);
	/** fXgN^ */
	virtual ~CCommandItem();

public:
	/** ACR擾 */
	HICON GetIcon() const { return m_hIcon; }
	/** ACRt@C擾 */
	LPCTSTR GetIconFileName() const { return m_strIconFile; }
	/** ACRt@Cݒ */
	void SetIconFileName(LPCTSTR lpszIconFile) { m_strIconFile = lpszIconFile; }
	/** ACRCfbNX擾 */
	int GetIconIndex() const { return m_nIconIndex; }
	/** ACRCfbNXݒ */
	void SetIconIndex(int nIndex) { m_nIconIndex = nIndex; }
	/** ^Cg擾 */
	LPCTSTR GetTitle() const { return m_strTitle; }
	/** ^Cgݒ */
	void SetTitle(LPCTSTR lpszTitle) { m_strTitle = lpszTitle; }
	/** N擾 */
	LPCTSTR GetLink() const { return m_strLink; }
	/** Nݒ */
	void SetLink(LPCTSTR lpszLink) { m_strLink = lpszLink; }
	/** ƃtH_擾 */
	LPCTSTR GetWorkFolder() const { return m_strWorkFolder; }
	/** ƃtH_ݒ */
	void SetWorkFolder(LPCTSTR lpszWorkFolder) { m_strWorkFolder = lpszWorkFolder; }
	/** EBhȆ傫擾 */
	WORD GetShowWindow() const { return m_wShowWindow; }
	/** EBhȆ傫ݒ */
	void SetShowWindow(WORD wShowWindow) { m_wShowWindow = wShowWindow; }
	/** Rg擾 */
	LPCTSTR GetComment() const { return m_strComment; }
	/** Rgݒ */
	void SetComment(LPCTSTR lpszComment) { m_strComment = lpszComment; }
	/** ϐ̍s擾 */
	int GetEnvLineCount() const { return (int) m_arstrEnv.GetSize(); }
	/** ϐ̎擾 */
	LPCTSTR GetEnv(int nIndex) const { return m_arstrEnv.GetAt(nIndex); }
	/** ϐ̐ݒ */
	BOOL SetEnv(LPCTSTR lpszEnv);
	/** j[\̎擾 */
	LPCTSTR GetMenuTitle() const { return m_lpszMenuDisp; }
	/** ANZ[^ʒu */
	int GetAccelaratorPosition() const { return m_nAcc; }
	/** ANZ[^ʒu */
	UINT GetAccelaratorKey() const { return m_nAccKey; }
	/** 傫ACR擾 */
	HICON ExtractLargeIcon() { return ::ExtractIcon(::AfxGetInstanceHandle(), GetIconFileName(), (UINT) GetIconIndex()); }

	/** ftHgACRnh̍쐬 */
	void CreateDefaultIcon();
	/** ACRnh̍쐬 */
	void CreateHicon();
	/** j[\̍쐬 */
	void CreateMenuTitle();

	/** t@C̓ǂݍ */
	static CCommandItem* Read(C8riStringFile* pFile);
	/** t@Cւ̂̓ǂݍ */
	BOOL Write(FILE* pFile, int nIndex);

	/** Wu̎s */
	BOOL Exec();

	/** Ǘ҂ƂăWu̎s */
	BOOL ExecAdmin(LPCTSTR lpszUser, LPCTSTR lpszPassword);

	/** Nst@C擾 */
	static void GetExecPathName(CString& strPathName);
	/** s\𒲂ׂ */
	static BOOL IsExecutable(LPCTSTR lpszExe);
	/** ϐ쐬 */
	void CreateEnvironment() { m_env.CreateEnvironmentStrings(); }

public:
	// Iy[^
	/** sIy[^ */
	BOOL operator!=(const CCommandItem&);
	/** Iy[^ */
	BOOL operator==(const CCommandItem&);

private:
	/** ϐs̒ǉ */
	void AddEnv(LPCTSTR lpszEnv);
	/** t@Cϐ̓ǂݍ */
	static BOOL ReadEnv(C8riStringFile* pFile, CCommandItem* pItem);
	/** t@C֊ϐ̏ */
	BOOL WriteEnv(FILE* pFile);
	/** 1so */
	static size_t WriteLine(LPCTSTR lpszLine, FILE* pFile);
	/** L[o */
	static size_t WriteKey(LPCTSTR lpszLine, FILE* pFile);

private:
	/** ACRt@C */
	CString m_strIconFile;
	/** ACRt@CCfbNX */
	int m_nIconIndex;
	/** ACRC[W */
	HICON m_hIcon;
	/** ^Cg */
	CString m_strTitle;
	/** N */
	CString m_strLink;
	/** ƃtH_ */
	CString m_strWorkFolder;
	/** EBhȆ傫 */
	WORD m_wShowWindow;
	/** Rg */
	CString m_strComment;
	/** ϐ */
	CStringArray m_arstrEnv;
	/** ϐNX */
	CEnvSet* m_pEnvSet;
	/** j[\ */
	LPTSTR m_lpszMenuDisp;
	/** ANZ[^ʒu */
	int m_nAcc;
	/** ANZ[^L[ */
	UINT m_nAccKey;
	/** ϐIuWFNg */
	CEnvSet m_env;
};
