//-----------------------------------------------------------------------------
// Desc:	ϐZbg
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Rienbu.h"
#include "EnvSet.h"

// CEnvSet

/**
 * WXgN^
 */
CEnvSet::CEnvSet() : CObject()
{
}

/**
 * fXgN^
 */
CEnvSet::~CEnvSet()
{
	Empty();
}

// CEnvSet o֐

/**
 * ϐIuWFNgɂ
 */
void CEnvSet::Empty()
{
	INT_PTR i;
	// [U`ϐz̍폜
	for (i = 0; i < m_arUser.GetSize(); i++) {
		delete m_arUser.GetAt(i);
	}
	m_arUser.RemoveAll();
	m_arUser.FreeExtra();
	// VXeϐz̍폜
	for (i = 0; i < m_arSystem.GetSize(); i++) {
		delete m_arSystem.GetAt(i);
	}
	m_arSystem.RemoveAll();
	m_arSystem.FreeExtra();
}

/**
 * ϐǉ
 * @param lpszEnv [in] ǉϐ
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CEnvSet::Add(LPCTSTR lpszEnv)
{
	CString str = lpszEnv;
	int nPos = str.Find(_T('='));
	if (nPos < 1) {
		return FALSE;
	}

	// Eɕ
	CString strLeft = str.Left(nPos);
	CString strRight = str.Right(str.GetLength() - nPos - 1);
	strLeft.Trim();	// ÕXy[X폜
	if (strLeft.IsEmpty() != FALSE) {
		return FALSE;
	}
	strRight.Trim();	// ÕXy[X폜

	// [Uϐ쐬
	CUserEnv* pEnv = new CUserEnv(this);
	pEnv->SetValue(strLeft, strRight);
	m_arUser.Add(pEnv);	// zɒǉ

	return TRUE;
}

/**
 * ϐ쐬
 */
void CEnvSet::CreateEnvironmentStrings()
{
	// eϐ쐬
#ifdef _UNICODE
	LPTSTR* lplpszTemp = _wenviron;
#else
	LPTSTR* lplpszTemp = _environ;
#endif
	// ϐCSystemEnvzɕύX
	CSystemEnv* pSysEnv;
	int nPos;
	CString str, strLeft, strRight;
	while (*lplpszTemp != 0) {
		// L[ƒlɕ
		str = *lplpszTemp;
		nPos = str.Find(_T('='));
		if (nPos > -1) {
			strLeft = str.Left(nPos);
			strRight = str.Right(str.GetLength() - nPos - 1);
			pSysEnv = new CSystemEnv(this);
			pSysEnv->SetValue(strLeft, strRight);
			m_arSystem.Add(pSysEnv);
		}
		// |C^i߂
		lplpszTemp++;
	}

	// [U`ϐ
	INT_PTR i, j;
	CUserEnv* pEnv;
	for (i = 0; i < m_arUser.GetSize(); i++) {
		pEnv = (CUserEnv*) m_arUser.GetAt(i);
		pEnv->LookupNewValue();	// Vl쐬
		for (j = 0; j < m_arSystem.GetSize(); j++) {
			pSysEnv = (CSystemEnv*) m_arSystem.GetAt(j);
			if (pSysEnv->AddIfKeyEquals(*pEnv) != FALSE) {
				break;
			}
		}
		// Ȃꍇ͐Vϐł
		if (j == m_arSystem.GetSize()) {
			pSysEnv = new CSystemEnv(this);
			pSysEnv->SetValue(pEnv->GetKey(), pEnv->GetNewValue());
			m_arSystem.Add(pSysEnv);
		}
	}
}

/**
 * ϐ𒲂ׂ
 * @param lpszKey [in] l𒲂ׂL[
 * @return ݐݒ肳Ăϐ̒l
 */
LPCTSTR CEnvSet::LookupEnvironment(LPCTSTR lpszKey)
{
	CSystemEnv* pSysEnv;
	for (INT_PTR i = 0; i < m_arSystem.GetSize(); i++) {
		pSysEnv = (CSystemEnv*) m_arSystem.GetAt(i);
		if (pSysEnv->GetKey().CompareNoCase(lpszKey) == 0) {
			return pSysEnv->GetNewValue();	// ϐ
		}
	}

	return _T("");	// ϐȂ
}

/**
 * Vϐobt@Ɏ擾
 * @return VϐZbg
 */
LPBYTE CEnvSet::GetNewEnvironment()
{
	int nSize, nTotalSize;
	nTotalSize = 0;
	CSystemEnv* pSysEnv;
	INT_PTR i;
	for (i = 0; i < m_arSystem.GetSize(); i++) {
		pSysEnv = (CSystemEnv*) m_arSystem.GetAt(i);
		nSize = ::lstrlen(pSysEnv->GetNewValue()) + ::lstrlen(pSysEnv->GetKey());
		if (nSize > 0) {
			nTotalSize += (nSize + 2);
		}
	}

	if (nTotalSize < 1) {
		return NULL;	// Vϐ͖
	}
	nTotalSize += 10;	// ]T

	int nAlloc = nTotalSize * sizeof(TCHAR);
	LPBYTE lpszNewEnv = new BYTE[nAlloc];
	::ZeroMemory(lpszNewEnv, nAlloc);
	LPTSTR lpszTemp = (LPTSTR) lpszNewEnv;
	for (i = 0; i < m_arSystem.GetSize(); i++) {
		pSysEnv = (CSystemEnv*) m_arSystem.GetAt(i);
		nSize = ::lstrlen(pSysEnv->GetNewValue()) + ::lstrlen(pSysEnv->GetKey());
		if (nSize > 0) {
			// Vϐ̃Rs[
			::wsprintf(lpszTemp, _T("%s=%s"), pSysEnv->GetKey(), pSysEnv->GetNewValue());
#ifdef _DEBUG
			::TRACE(_T("ENV = %s\n"), lpszTemp);
#endif
			lpszTemp += (nSize + 2);
		}
	}

	return lpszNewEnv;	// Vϐ
}

// [U`ϐ
/**
 * WRXgN^
 */
CEnvSet::CUserEnv::CUserEnv(CEnvSet* pEnvSet) : CObject()
{
	m_pSet = pEnvSet;
	m_lpszNewEnv = NULL;
}

/**
 * fXgN^
 */
CEnvSet::CUserEnv::~CUserEnv()
{
	delete[] m_lpszNewEnv;
}

/**
 * lݒ
 * @param lpszKey [in] L[
 * @param lpszValue [in] l
 */
void CEnvSet::CUserEnv::SetValue(LPCTSTR lpszKey, LPCTSTR lpszValue)
{
	m_strKey = lpszKey;
	m_strValue = lpszValue;
}

/**
 * Vϐl̎擾
 * @return Vϐl
 */
LPCTSTR CEnvSet::CUserEnv::GetNewValue()
{
	if (m_lpszNewEnv == NULL) {
		return GetValue();
	}

	return m_lpszNewEnv;
}

/** 
 * Vϐl̍쐬
 */
void CEnvSet::CUserEnv::LookupNewValue()
{
	delete[] m_lpszNewEnv;
	m_lpszNewEnv = NULL;

	CString strNew;
	strNew.Empty();
	int nPos;
	CString str = GetValue();
	CString strLeft, strRight;
	while (TRUE) {
		nPos = str.Find(_T('%'));
		if (nPos < 0) {
			strNew += str;	// ϐ݂Ȃ
			break;
		}
		// %̍
		strLeft = str.Left(nPos);
		// %̉E
		strRight = str.Right(str.GetLength() - nPos - 1);
		nPos = strRight.Find(_T('%'));
		if (nPos < 0) {
			strNew += str;	// ϐ݂Ȃ
			break;
		}

		// ϐ̍ǉ
		strNew += strLeft;
		// ϐT
		strNew += m_pSet->LookupEnvironment(strRight.Left(nPos));

		// ̒lT߂ɕč\z
		str = strRight.Right(strRight.GetLength() - nPos - 1);
	}

	// č\z
	int nLen = ::lstrlen(strNew) + 1;
	m_lpszNewEnv = new TCHAR[nLen];
	::lstrcpy(m_lpszNewEnv, strNew);

	TRACE(_T("%s\n"), m_lpszNewEnv);
}

// VXeϐ
/**
 * RXgN^
 * @param pEnvSet [in] ϐZbgւ̃|C^
 */
CEnvSet::CSystemEnv::CSystemEnv(CEnvSet* pEnvSet) : CUserEnv(pEnvSet)
{
	m_pUser = NULL;
}

/**
 * fXgN^
 */
CEnvSet::CSystemEnv::~CSystemEnv()
{
}

/**
 *  L[H
 * @param refEnv [in] L[r郆[U`ϐ
 * @return L[ꍇ0ȊOAႤꍇ0
 */
BOOL CEnvSet::CSystemEnv::AddIfKeyEquals(CUserEnv& refEnv)
{
	if (m_strKey.CompareNoCase(refEnv.GetKey()) == 0) {
		m_pUser = &refEnv;
		return TRUE;	// 
	}
	return FALSE;	// Ȃ
}

/**
 * Vϐl̎擾
 * @return Vϐl
 */
LPCTSTR CEnvSet::CSystemEnv::GetNewValue()
{
	if (m_pUser != NULL) {
		return m_pUser->GetNewValue();
	}

	return GetValue();
}
