//-----------------------------------------------------------------------------
// Desc:	MFCAvP[V
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Rienbu.h"
#include "MainFrm.h"

#include "RienbuDoc.h"
#include "RienbuView.h"
#include "CommandItem.h"
#include "8riStringFile.h"
#include "SingleInstance.h"
#include "Impersonate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#ifdef _WIN32
#define LIBEAY_DLL			_T("LIBEAY32.dll")
#define SSLEAY_DLL			_T("SSLEAY32.dll")
#else
#ifdef _WIN64
#define LIBEAY_DLL			_T("LIBEAY64.dll")
#define SSLEAY_DLL			_T("SSLEAY64.dll")
#endif
#endif

// CRienbuApp
BEGIN_MESSAGE_MAP(CRienbuApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CRienbuApp::OnAppAbout)
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
END_MESSAGE_MAP()

// CRienbuApp RXgNV
HMODULE CRienbuApp::m_hEay = NULL;
HMODULE CRienbuApp::m_hSsl = NULL;
EVP_BF_CBC CRienbuApp::m_lpfn_evp_bf_cbc = NULL;
EVP_MD5 CRienbuApp::m_evp_lpfn_md5 = NULL;
RAND_SEED CRienbuApp::m_lpfn_rand_seed = NULL;
RAND_PSEUDO_BYTES CRienbuApp::m_lpfn_pseudo_bytes = NULL;
EVP_BYTESTOKEY CRienbuApp::m_lpfn_bytestokey = NULL;
EVP_CIPHER_CTX_INIT CRienbuApp::m_lpfn_evp_cipher_ctx_init = NULL;
EVP_CIPHERINIT CRienbuApp::m_lpfn_evp_cipherinit = NULL;
EVP_CIPHERUPDATE CRienbuApp::m_lpfn_evp_cipherupdate = NULL;
EVP_CIPHERFINAL CRienbuApp::m_lpfn_evp_cipherfinal = NULL;
EVP_CIPHER_CTX_CLEANUP CRienbuApp::m_lpfn_evp_cctx_cleanup = NULL;
SSL_LOAD_ERROR_STRINGS CRienbuApp::m_lpfn_ssl_load_error_strings = NULL;
SSL_LIBRARY_INIT CRienbuApp::m_lpfn_ssl_library_init = NULL;
ERR_REMOVE_STATE CRienbuApp::m_lpfn_err_remove_state = NULL;
ERR_FREE_STRINGS CRienbuApp::m_lpfn_err_free_strings = NULL;

/**
 * RXgN^
 */
CRienbuApp::CRienbuApp()
{
	EnableHtmlHelp();

	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	m_szFile[0] = 0;
	m_pSingleInst = NULL;
	m_nMode = MODE_NORMAL;
	m_pAdmin = NULL;
}

// B CRienbuApp IuWFNgłB
CRienbuApp theApp;

/**
 * 
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::InitInstance()
{
	// /s̓X^[gAbṽR}hC
	// /c̓X^[gAbvݒ莞̃R}hC
	CString str = m_lpCmdLine;
	str.MakeLower();	// 
	if (::_tcsncmp(_T("/s"), str, ::lstrlen(_T("/s"))) == 0) {
		m_nMode = MODE_STARTUP;
	}
	else if (::_tcsncmp(_T("/c"), str, ::lstrlen(_T("/c"))) == 0) {
		m_nMode = MODE_CONFIG;
	}
	if (m_nMode != MODE_NORMAL) {
		// OpenSSLJn
		if (CRienbuApp::InitiallizeSSL() == FALSE) {
			return FALSE;
		}
		m_pAdmin = new CImpersonate();
		if (m_pAdmin != NULL) {
			if (m_pAdmin->Impersonate(m_nMode) == FALSE) {
				delete m_pAdmin;
				m_pAdmin = NULL;
				return FALSE;
			}
		}
		else {
			return FALSE;
		}
	}

	// ŏ̃CX^Xł邩𒲂ׂ
	m_pSingleInst = new CSingleInstance();
	if (m_pSingleInst == NULL) {
		return FALSE;	// 쐬s
	}
	if (m_pSingleInst->IsOnlyInstance() == FALSE) {
		return TRUE;	// ŏ̃CX^Xł͂Ȃ
	}
	// AvP[V }jtFXg visual X^CLɂ邽߂ɁA
	// ComCtl32.dll Version 6 ȍ~̎gpw肷ꍇ́A
	// Windows XP  InitCommonControlsEx() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// AvP[VŎgp邷ׂẴR Rg[ NX܂߂ɂ́A
	// ݒ肵܂B
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);
	CWinApp::InitInstance();

	// OLE Cu܂B
	if (AfxOleInit() == FALSE) {
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();

	// ̃AvP[ṼWXgL[
	::free((void*) m_pszAppName);
	m_pszAppName = ::_tcsdup(_T("Rienbu"));
	SetRegistryKey(_T("Comona"));

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CRienbuDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CRienbuView));
	if (pDocTemplate == FALSE) {
		return FALSE;
	}
	AddDocTemplate(pDocTemplate);

	// DDEAfile open ȂǕW̃VF R}h̃R}h C͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// t@C̗p
	if (PrepareFileName() == FALSE) {
		return FALSE;
	}
	PrepreItems();	// ACe̗p
	// [hX^[gAbv̏ꍇR}hsďI
	if (m_nMode == MODE_STARTUP) {
		return ExecStartup();
	}

	// R}h CŎw肳ꂽfBXpb` R}hłBAvP[V
	// /RegServerA/RegisterA/Unregserver ܂ /Unregister ŋNꂽꍇAFalse Ԃ܂B
	if (ProcessShellCommand(cmdInfo) == FALSE) {
		return FALSE;
	}

	DWORD wShow;
	if (GetStartupMode() == MODE_NORMAL) {
		wShow = SW_SHOWMINNOACTIVE;	// ʏ탂[h
	}
	else {
		wShow = SW_SHOW;	// Ǘ[h
	}

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	m_pMainWnd->ShowWindow(wShow);
	m_pMainWnd->UpdateWindow();
	// ڔ݂ꍇɂ̂ DragAcceptFiles ĂяoĂB
	//  SDI AvP[Vł́AProcessShellCommand ̒ɂ̌ĂяoȂ΂Ȃ܂B
	return TRUE;
}

// AvP[Ṽo[WɎg CAboutDlg _CAO
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

// 
protected:
	DECLARE_MESSAGE_MAP()
};

/**
 * RXgN^
 */
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

/**
 * AoEg_CAO̕\
 */
void CRienbuApp::OnAppAbout()
{
	((CMainFrame*) m_pMainWnd)->DialogOpend();
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
	((CMainFrame*) m_pMainWnd)->DialogClosed();
}

// CRienbuApp bZ[W nh
/**
 * tH_̎擾
 * @param lpszFolder [out] fXNgbvtH_擾obt@[MAX_PATH + 1]
 * @param csidl [in] XyVtH_ʎq
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::GetSpecialFolder(LPTSTR lpszFolder, int csidl)
{
	// fXNgbvtH_Ƃ
	IMalloc* pMalloc;
	ITEMIDLIST* pidl;
	if (::SHGetMalloc(&pMalloc) == NOERROR) {
		if (::SHGetSpecialFolderLocation(::GetDesktopWindow(), csidl, &pidl) == NOERROR) {
			if (::SHGetPathFromIDList(pidl, lpszFolder) == FALSE) {
				lpszFolder[0] = 0;
			}
			pMalloc->Free(pidl);
		}
		else {
			pMalloc->Release();
		}
		pMalloc->Release();
	}

	if (lpszFolder[0] == 0) {
		return FALSE;
	}

	return TRUE;
}

/**
 * t@Cp
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::PrepareFileName()
{
	// AvP[Vf[^pX̎擾
	if (CRienbuApp::GetSpecialFolder(m_szFile, CSIDL_APPDATA) == FALSE) {
		return FALSE;
	}
	if (m_szFile[0] == 0) {
		return FALSE;
	}
	if (m_szFile[::lstrlen(m_szFile) - 1] != _T('\\')) {
		::lstrcat(m_szFile, _T("\\"));
	}
	::lstrcat(m_szFile, _T("Comona"));
	if (FindDirectory(m_szFile) == FALSE) {
		return FALSE;
	}
	::lstrcat(m_szFile, _T("\\Rienbu"));
	if (FindDirectory(m_szFile) == FALSE) {
		return FALSE;
	}

	// ꎞt@C쐬
	::lstrcpy(m_szTempFile, m_szFile);
	::lstrcat(m_szTempFile, _T("\\Rienbu.tmp"));
	CRienbuApp::DeleteFileOrDirectory(m_szTempFile);

	// t@C
	if (m_nMode == MODE_NORMAL) {
		::lstrcat(m_szFile, _T("\\Rienbu.conf"));
	}
	else {
		::lstrcat(m_szFile, _T("\\Startup.conf"));
	}
	m_szFile[MAX_PATH] = 0;

	return TRUE;
}

/**
 * fBNgTȂ΍쐬
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::FindDirectory(LPCTSTR lpszPathName)
{
	DWORD dwAttr = ::GetFileAttributes(lpszPathName);
	if (dwAttr == 0xFFFFFFFF) {
		if (::CreateDirectory(lpszPathName, NULL) == FALSE) {
			return FALSE;
		}
	}
	else {
		if ((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == 0) {
			if (CRienbuApp::DeleteFile(lpszPathName) == FALSE) {
				return FALSE;
			}
			if (::CreateDirectory(lpszPathName, NULL) == FALSE) {
				return FALSE;
			}
		}
	}
	return TRUE;
}

/**
 * t@C폜
 * @param lpszPathName [in] 폜t@C
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::DeleteFile(LPCTSTR lpszPathName)
{
	DWORD dwAttr = ::GetFileAttributes(lpszPathName);
	if (dwAttr == 0xFFFFFFFF) {
		return TRUE;	// ݂Ȃ
	}

	if ((dwAttr & FILE_ATTRIBUTE_READONLY) != 0) {
		dwAttr ^= FILE_ATTRIBUTE_READONLY;
		if (::SetFileAttributes(lpszPathName, dwAttr) == FALSE) {
			return FALSE;
		}
	}

	return ::DeleteFile(lpszPathName);
}
/**
 * fBNg폜
 * @param lpszDir [in] 폜fBNg
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::DeleteDirectory(LPCTSTR lpszDir)
{
	BOOL fRet = TRUE;
	BOOL fFiles;
	WIN32_FIND_DATA fd;
	HANDLE hFind;
	TCHAR szPath[MAX_PATH];
	TCHAR szFile[MAX_PATH];

	DWORD dwAttr = ::GetFileAttributes(lpszDir);
	if (dwAttr == 0xFFFFFFFF) {
		return TRUE;	// ݂Ȃ
	}

	if (dwAttr & FILE_ATTRIBUTE_READONLY) {
		dwAttr ^= FILE_ATTRIBUTE_READONLY;
		if (::SetFileAttributes(lpszDir, dwAttr) == FALSE) {
			return FALSE;
		}
	}

	::wsprintf(szPath, _T("%s\\*.*"), lpszDir);
	hFind = ::FindFirstFile(szPath, &fd);
	if (hFind != INVALID_HANDLE_VALUE) {
		::FindNextFile(hFind, &fd);	// .
		fFiles = ::FindNextFile(hFind, &fd);	// ..
		while (fFiles != FALSE) {
			::wsprintf(szFile, _T("%s\\%s"), lpszDir, fd.cFileName);
			if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != FILE_ATTRIBUTE_DIRECTORY) {
				fRet = CRienbuApp::DeleteFile(szFile);
			}
			else {
				fRet = CRienbuApp::DeleteDirectory(szFile);
			}
			if (fRet == FALSE) {
				break;
			}
			fFiles = ::FindNextFile(hFind, &fd);
		}
		::FindClose(hFind);
	}

	if (fRet != FALSE) {
		fRet = ::RemoveDirectory(lpszDir);
	}

	return fRet;
}

/**
 * fBNgʏt@C킩ȂƂ肠폜
 * @param lpszPathName [in] 폜t@C
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::DeleteFileOrDirectory(LPCTSTR lpszPathName)
{
	DWORD dwAttr = ::GetFileAttributes(lpszPathName);
	if (dwAttr != 0xFFFFFFFF) {
		if ((dwAttr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY) {
			return CRienbuApp::DeleteDirectory(lpszPathName);	// ̖̃fBNgΏ
		}
		else {
			return CRienbuApp::DeleteFile(lpszPathName);	// ̖̃t@CΏ
		}
	}
	else {
		return TRUE;	// ݂Ȃ
	}
}

/**
 * ACe̗p
 */
void CRienbuApp::PrepreItems()
{
	C8riStringFile file;
	if (file.Open(GetFileName()) != FALSE) {
		CCommandItem* pItem = CCommandItem::Read(&file);
		while (pItem != NULL) {
			m_arItems.Add(pItem);
			pItem = CCommandItem::Read(&file);
		}
	}
}

/**
 * ACe̒ǉ
 * @param pItem [in] ǉACe
 * @param nAfter [in] ̃CfbNX̎ɒǉ
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::AddItem(CCommandItem* pItem, int nAfter)
{
	int nIndexAt;
	if (nAfter < 0) {
		// Ō
		nIndexAt = (int) m_arItems.GetCount();
	}
	else {
		nIndexAt = nAfter + 1;
	}

	// ǉ
	if (GetItemCount() > nIndexAt) {
		m_arItems.InsertAt(nIndexAt, pItem);
	}
	else {
		nIndexAt = GetItemCount();
		m_arItems.Add(pItem);
	}

	// t@Cɏ
	BOOL fRet = WriteFile();
	if (fRet == FALSE) {
		m_arItems.RemoveAt(nIndexAt);
	}
	return fRet;
}

/**
 * ACe̒u
 * @param pItem [in] uACe
 * @param nIndex [in] ̃CfbNX̃ACeu
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::ReplaceItem(CCommandItem* pItem, int nIndex)
{
	if (nIndex >= GetItemCount()) {
		return FALSE;
	}

	CCommandItem* pDelItem = GetItem(nIndex);
	m_arItems.SetAt(nIndex, pItem);

	// t@Cɏ
	BOOL fRet = WriteFile();
	if (fRet == FALSE) {
		m_arItems.SetAt(nIndex, pDelItem);
	}
	else {
		delete pDelItem;
	}

	return fRet;
}

/**
 * ACe̍폜
 * @param nIndex [in] ̃CfbNX̃ACe폜
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::DeleteItem(int nIndex)
{
	if (nIndex >= GetItemCount()) {
		return FALSE;
	}

	CCommandItem* pItem = GetItem(nIndex);
	m_arItems.RemoveAt(nIndex);

	// t@Cɏ
	BOOL fRet = WriteFile();
	if (fRet == FALSE) {
		if (GetItemCount() > nIndex) {
			m_arItems.InsertAt(nIndex, pItem);
		}
		else {
			m_arItems.Add(pItem);
		}
		m_arItems.InsertAt(nIndex, pItem);
	}
	else {
		delete pItem;
	}

	return fRet;
}

/**
 * t@C̏o
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::WriteFile()
{
	FILE* pf = NULL;

	BOOL fRet = TRUE;
	try {
		if (CRienbuApp::DeleteFileOrDirectory(m_szTempFile) == FALSE) {
			throw FALSE;
		}

		// ꎞt@CI[v
		errno_t err = ::_tfopen_s(&pf, m_szTempFile, _T("wb"));
		if (err != 0) {
			throw FALSE;
		}

#ifdef _UNICODE
		// UNICODE BOM
		WORD wBOM = UNICODE_BOM;
		size_t st = ::fwrite(&wBOM, 1, sizeof(WORD), pf);
		if (st != sizeof(WORD)) {
			throw FALSE;
		}
#endif

		CCommandItem* pItem;
		for (int i = 0; i < GetItemCount(); i++) {
			pItem = GetItem(i);
			if (pItem->Write(pf, i) == FALSE) {
				throw FALSE;
			}
		}

		// t@C̍폜
		if (CRienbuApp::DeleteFile(GetFileName()) == FALSE) {
			::DeleteFile(m_szTempFile);	// ŝňꎞt@C폜
			throw FALSE;
		}
	}
	catch (BOOL& f) {
		fRet = f;
	}

	if (pf != NULL) {
		::fclose(pf);
	}

	if (fRet != FALSE) {
		// t@C̕ύX
		fRet = ::MoveFile(m_szTempFile, GetFileName());
	}
	else {
		CRienbuApp::DeleteFileOrDirectory(m_szTempFile);
	}

	return fRet;
}
/**
 * CX^X̏I
 * @return ̏ꍇ0As̏ꍇ0ȊO
 */
int CRienbuApp::ExitInstance() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	for (INT_PTR i = 0; i < m_arItems.GetSize(); i++) {
		delete m_arItems.GetAt(i);
	}
	delete m_pSingleInst;
	delete m_pAdmin;

	// OpenSSLpI
	if (m_nMode != MODE_NORMAL) {
		CRienbuApp::SSLCleanupThread();
		CRienbuApp::CleanupSSL();
	}

	return CWinApp::ExitInstance();
}

/** 
 * ACe̎s
 */
void CRienbuApp::ExecItem(int nIndex)
{
	if (GetStartupMode() != MODE_NORMAL) {
		m_pAdmin->RevertToSelf();
	}
	if (nIndex < GetItemCount()) {
		CCommandItem* pItem = GetItem(nIndex);
		if (GetStartupMode() == MODE_NORMAL) {
			pItem->Exec();
		}
		else {
			pItem->ExecAdmin(m_pAdmin->GetUser(), m_pAdmin->GetPassword());
		}
	}
	if (GetStartupMode() != MODE_NORMAL) {
		m_pAdmin->ImpersonateAgain();
	}
}

/**
 * OpenSSLp֐
 * OpenSSL𗘗pꍇAvP[VłPxĂяoĂB
 * @return ̏ꍇ0ȊOAs̏ꍇ0
 */
BOOL CRienbuApp::InitiallizeSSL()
{
	// ŏMACAhXݒ
	CImpersonate::SetMacAddress();

	// Cu[h
	m_hEay = ::LoadLibrary(LIBEAY_DLL);
	m_hSsl = ::LoadLibrary(SSLEAY_DLL);
	if ((m_hEay == NULL) || (m_hSsl == NULL)) {
		return FALSE;
	}

	// ֐|C^̎擾
	CRienbuApp::m_lpfn_evp_bf_cbc = (EVP_BF_CBC) ::GetProcAddress(m_hEay, "EVP_bf_cbc");
	CRienbuApp::m_evp_lpfn_md5 = (EVP_MD5) ::GetProcAddress(m_hEay, "EVP_md5");
	CRienbuApp::m_lpfn_rand_seed = (RAND_SEED) ::GetProcAddress(m_hEay, "RAND_seed");
	CRienbuApp::m_lpfn_pseudo_bytes = (RAND_PSEUDO_BYTES) ::GetProcAddress(m_hEay, "RAND_pseudo_bytes");
	CRienbuApp::m_lpfn_bytestokey = (EVP_BYTESTOKEY) ::GetProcAddress(m_hEay, "EVP_BytesToKey");
	CRienbuApp::m_lpfn_evp_cipher_ctx_init = (EVP_CIPHER_CTX_INIT) ::GetProcAddress(m_hEay, "EVP_CIPHER_CTX_init");
	CRienbuApp::m_lpfn_evp_cipherinit = (EVP_CIPHERINIT) ::GetProcAddress(m_hEay, "EVP_CipherInit");
	CRienbuApp::m_lpfn_evp_cipherupdate = (EVP_CIPHERUPDATE) ::GetProcAddress(m_hEay, "EVP_CipherUpdate");
	CRienbuApp::m_lpfn_evp_cipherfinal = (EVP_CIPHERFINAL) ::GetProcAddress(m_hEay, "EVP_CipherFinal");
	CRienbuApp::m_lpfn_evp_cctx_cleanup = (EVP_CIPHER_CTX_CLEANUP) ::GetProcAddress(m_hEay, "EVP_CIPHER_CTX_cleanup");
	CRienbuApp::m_lpfn_ssl_load_error_strings = (SSL_LOAD_ERROR_STRINGS) ::GetProcAddress(m_hSsl, "SSL_load_error_strings");
	CRienbuApp::m_lpfn_ssl_library_init = (SSL_LIBRARY_INIT) ::GetProcAddress(m_hSsl, "SSL_library_init");
	CRienbuApp::m_lpfn_err_remove_state = (ERR_REMOVE_STATE) ::GetProcAddress(m_hEay, "ERR_remove_state");
	CRienbuApp::m_lpfn_err_free_strings = (ERR_FREE_STRINGS) ::GetProcAddress(m_hEay, "ERR_free_strings");
	// OpenSSL 
	// G[̃[h
	m_lpfn_ssl_load_error_strings();
	// Cu
	m_lpfn_ssl_library_init();

	return TRUE;
}


/**
 * OpenSSLXbhN[Abv֐
 * OpenSSLʐMsXbhIƂKĂяoĂB
 */
void CRienbuApp::SSLCleanupThread()
{
	// OpenSSL̃XbhN[Abv
	if (m_lpfn_err_remove_state != NULL) {
		m_lpfn_err_remove_state(GetCurrentThreadId());
	}
}

/**
 * OpenSSLpI֐
 */
void CRienbuApp::CleanupSSL()
{
	// OpenSSL̏I
	if (m_lpfn_err_free_strings != NULL) {
		m_lpfn_err_free_strings();	// OpenSSLXgOJ
	}

	// Cut[
	if (m_hSsl != NULL) {
		::FreeLibrary(m_hSsl);
		m_hSsl = NULL;
	}
	if (m_hEay != NULL) {
		::FreeLibrary(m_hEay);
		m_hEay = NULL;
	}
}

/**
 * X^[gAbvs
 * @return ̏ꍇ0As̏ꍇ0ȊO
 */
BOOL CRienbuApp::ExecStartup()
{
	m_pAdmin->RevertToSelf();	// ̃[Uɖ߂
	BOOL fRet = TRUE;
	CCommandItem* pItem;
	for (INT_PTR i = 0; i < m_arItems.GetSize(); i++) {
		pItem = (CCommandItem*) m_arItems.GetAt(i);
		if (pItem->ExecAdmin(m_pAdmin->GetUser(), m_pAdmin->GetPassword()) == FALSE) {
			fRet = FALSE;
		}
	}
	return fRet;
}

/**
 * OpX̎擾
 * @param lpszShortPath [in] V[gpXmȂpX
 * @param lpszLongPath [out] V[gpXmȂpX
 * @param cbBuff [in] lpszLongPath̒
 * @return ̏ꍇ0As̏ꍇ0ȊO
 */
BOOL CRienbuApp::GetLongPathName(LPCTSTR lpszShortPath, LPTSTR lpszLongPath, DWORD cbBuff)
{
	wchar_t wcShortPath[MAX_PATH + 1];
	ULONG chEaten;
	ITEMIDLIST* pidl;
	IShellFolder* pshf;
	IMalloc* pMalloc;
	BOOL fRet = FALSE;

	if (::SHGetMalloc(&pMalloc) == NOERROR) {
		if (::SHGetDesktopFolder(&pshf) == NOERROR) {
#ifdef _UNICODE
			::lstrcpyW(wcShortPath, lpszShortPath);
#else
			::MultiByteToWideChar(CP_ACP, 0, lpszShortPath, -1, wcShortPath, cbBuff ); 
#endif
			if (pshf->ParseDisplayName(NULL, NULL, wcShortPath, &chEaten, &pidl, NULL) == NOERROR) {
				if (::SHGetPathFromIDList(pidl, lpszLongPath)) {
					fRet = TRUE;
				}
				pMalloc->Free(pidl);
			}
			pshf->Release();
		}
		pMalloc->Release();
	}

	return fRet;
}
