//-----------------------------------------------------------------------------
// Desc:	MFCr[
// Company:	Comona Co., Ltd.
// Date:	(2005/09/30)
// Author:	Toru Kageyama<kageyama@comona.co.jp>
// 쌠͗LЃRiɋA܂B
// pEzzEς͈̐؂܂B
// 쌠҂͖{\[XR[hpɂĐQɑ΂Ĉ؂̐ӔC𕉂܂B
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Rienbu.h"

#include "RienbuDoc.h"
#include "RienbuView.h"
#include "CommandDialog.h"
#include "CommandItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CRienbuView

IMPLEMENT_DYNCREATE(CRienbuView, CListView)

BEGIN_MESSAGE_MAP(CRienbuView, CListView)
	ON_WM_CREATE()
	ON_WM_KILLFOCUS()
	ON_WM_DESTROY()
	ON_COMMAND(IDM_ADDITEM, &CRienbuView::OnAdditem)
	ON_COMMAND(IDM_DELITEM, &CRienbuView::OnDelitem)
	ON_UPDATE_COMMAND_UI(IDM_DELITEM, &CRienbuView::OnUpdateDelitem)
	ON_COMMAND(IDM_PROPITEM, &CRienbuView::OnPropitem)
	ON_UPDATE_COMMAND_UI(IDM_PROPITEM, &CRienbuView::OnUpdatePropitem)
	ON_NOTIFY_REFLECT(NM_DBLCLK, &CRienbuView::OnNMDblclk)
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(IDM_ADDITEM, &CRienbuView::OnUpdateAdditem)
	ON_COMMAND(IDM_EXECUTE, &CRienbuView::OnExecute)
	ON_UPDATE_COMMAND_UI(IDM_EXECUTE, &CRienbuView::OnUpdateExecute)
	ON_UPDATE_COMMAND_UI(IDM_UP, &CRienbuView::OnUpdateUp)
	ON_UPDATE_COMMAND_UI(IDM_DOWN, &CRienbuView::OnUpdateDown)
	ON_COMMAND(IDM_UP, &CRienbuView::OnUp)
	ON_COMMAND(IDM_DOWN, &CRienbuView::OnDown)
	ON_WM_CHAR()
END_MESSAGE_MAP()

// CRienbuView RXgNV/fXgNV

/**
 * WRXgN^
 */
CRienbuView::CRienbuView()
{
	// TODO: \zR[hɒǉ܂B
}

/**
 * fXgN^
 */
CRienbuView::~CRienbuView()
{
}

/**
 * \Oʒmnh
 */
BOOL CRienbuView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	cs.style |= LVS_REPORT;

	return CListView::PreCreateWindow(cs);
}

/**
 * \ʒmnh
 */
void CRienbuView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	CString str, strFile, strDir;
	LV_COLUMN col;
	TCHAR szBuff[32];

	// XgRg[̎擾
	CListCtrl& refList = GetListCtrl();

	// AvP[VNX̎擾
	CWinApp* pApp = ::AfxGetApp();

	// L[
	strDir.LoadString(IDS_COLUMNWIDTH);
	strFile.LoadString(IDS_SETTINGSECTION);

	// ^Cg
	str.LoadString(IDS_CMDTITLE);
	col.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	col.fmt = LVCFMT_LEFT;
	::wsprintf(szBuff, strDir, 0);
	col.cx = pApp->GetProfileInt(strFile, szBuff, 100);
	col.iSubItem = 0;
	col.pszText = str.GetBufferSetLength(str.GetLength());
	refList.InsertColumn(0, &col);
	// 
	str.LoadString(IDS_CMDDESC);
	col.fmt = LVCFMT_LEFT;
	::wsprintf(szBuff, strDir, 1);
	col.cx = pApp->GetProfileInt(strFile, szBuff, 300);
	col.iSubItem = 1;
	col.pszText = str.GetBufferSetLength(str.GetLength());
	refList.InsertColumn(1, &col);

	// ACRC[W
	m_imagesmall.Create(::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), ILC_COLOR24 | ILC_MASK, 4, 4);
	refList.SetImageList(&m_imagesmall, LVSIL_SMALL);
	// X^C|[gɕύX
	LONG lStyle = ::GetWindowLong(refList.GetSafeHwnd(), GWL_STYLE);
	lStyle ^= LVS_ICON;
	lStyle |= LVS_REPORT;
	::SetWindowLong(refList.GetSafeHwnd(), GWL_STYLE, lStyle);
	// sS̑IAsI
	refList.ModifyStyle(0, LVS_SINGLESEL);
	refList.SetExtendedStyle(refList.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

	SetItemsToList();

	// ʒu킹
	pApp->m_pMainWnd->SendMessage(WM_INITIALUPDATE);
}

// CRienbuView ff

#ifdef _DEBUG
void CRienbuView::AssertValid() const
{
	CListView::AssertValid();
}

void CRienbuView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CRienbuDoc* CRienbuView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRienbuDoc)));
	return (CRienbuDoc*)m_pDocument;
}
#endif //_DEBUG


// CRienbuView bZ[W nh
/**
 * WM_CREATEnh
 */
int CRienbuView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CListView::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}

	// TODO:  ɓȍ쐬R[hǉĂB
	if (m_wndHeaderCtrl.SubclassWindow(GetListCtrl().GetDlgItem(0)->GetSafeHwnd()) == 0) {
		return -1;
	}

	return 0;
}

/**
 * WM_KILLFOCUSnh
 */
void CRienbuView::OnKillFocus(CWnd* pNewWnd)
{
	CListView::OnKillFocus(pNewWnd);

	// TODO: ɃbZ[W nh R[hǉ܂B
	m_wndHeaderCtrl.KillFocus();
}

/**
 * WM_DESTROYnh
 */
void CRienbuView::OnDestroy()
{
	CListView::OnDestroy();

	RECT rect;
	int i;
	CString str, str2;
	TCHAR szBuff[32];

	CWinApp* pApp = AfxGetApp();

	// ݒ̕ۑ
	str.LoadString(IDS_COLUMNWIDTH);
	str2.LoadString(IDS_SETTINGSECTION);
	for (i = 0; i < m_wndHeaderCtrl.GetItemCount(); i++) {
		m_wndHeaderCtrl.GetItemRect(i, &rect);
		::wsprintf(szBuff, str, i);
		pApp->WriteProfileInt(str2, szBuff, rect.right - rect.left);
	}
}

/**
 * ACeǉ
 */
void CRienbuView::OnAdditem()
{
	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	if (pApp->GetItemCount() >= MAX_ITEMS) {
		return;	// 32܂łɂĂ
	}

	// TODO: ɃR}h nh R[hǉ܂B
	CCommandDialog dlg;
	if (dlg.DoModal() == IDOK) {
		CCommandItem* pItem = dlg.GetCommandItem();
		int nPos = GetSelectedIndex();
		if (pApp->AddItem(pItem, nPos) != FALSE) {
			CListCtrl& refList = GetListCtrl();
			if (nPos < 0) {
				nPos = refList.GetItemCount();
			}
			else {
				nPos++;
			}
			int nImage = m_imagesmall.Add(pItem->GetIcon());	// ACR𑫂
			int nItem = refList.InsertItem(nPos, pItem->GetMenuTitle(), nImage);	// O
			refList.SetItemData(nItem, (DWORD_PTR) pItem);	// f[^ƃXgт
			refList.SetItem(nPos, 1, LVIF_TEXT, pItem->GetComment(), 0, 0, 0, 0);	// fBNg
			refList.SetItemState(nPos, LVIS_SELECTED, LVIS_SELECTED);
		}
		else {	// s
			delete pItem;
		}
	}
}

/**
 * ACe̍폜
 */
void CRienbuView::OnDelitem()
{
	// TODO: ɃR}h nh R[hǉ܂B
	CListCtrl& refList = GetListCtrl();
	if (refList.GetSelectedCount() == 0) {
		return;	// Ώۂ
	}

	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	int nPos = GetSelectedIndex();
	CCommandItem* pItem = pApp->GetItem(nPos);
	CString str, strCaption;
	str.Format(IDS_TPLTDELETEITEM, pItem->GetMenuTitle());
	strCaption.LoadString(IDS_CAPTION);
	if (MessageBox(str, strCaption, MB_ICONQUESTION | MB_YESNO) == IDYES) {
		if (pApp->DeleteItem(nPos) != FALSE) {
			refList.DeleteItem(nPos);
		}
	}
}

/**
 * ACe폜̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdateDelitem(CCmdUI *pCmdUI)
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	CListCtrl& refList = GetListCtrl();
	pCmdUI->Enable(refList.GetSelectedCount() == 1);
}

/**
 * ACevpeB\
 */
void CRienbuView::OnPropitem()
{
	// TODO: ɃR}h nh R[hǉ܂B
	CListCtrl& refList = GetListCtrl();
	if (refList.GetSelectedCount() == 0) {
		return;	// Ώۂ
	}

	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	int nPos = GetSelectedIndex();
	CCommandDialog dlg;
	dlg.SetCommandItem(pApp->GetItem(nPos));
	if (dlg.DoModal() == IDOK) {
		CCommandItem* pItem = dlg.GetCommandItem();
		CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
		if ((*pItem) == (*(pApp->GetItem(nPos)))) {
			delete pItem;
			return;	// Ȃ̂łȂɂȂ
		}
		int nPos = GetSelectedIndex();
		if (pApp->ReplaceItem(pItem, nPos) != FALSE) {
			CListCtrl& refList = GetListCtrl();
			m_imagesmall.Replace(nPos, pItem->GetIcon());	// ACRւ
			refList.SetItem(nPos, 0, LVIF_TEXT, pItem->GetMenuTitle(), 0, 0, 0, 0);	// O
			refList.SetItemData(nPos, (DWORD_PTR) pItem);	// f[^ƃXgт
			refList.SetItem(nPos, 1, LVIF_TEXT, pItem->GetComment(), 0, 0, 0, 0);	// fBNg
		}
		else {	// s
			delete pItem;
		}
	}
}

/**
 * ACevpeB\̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdatePropitem(CCmdUI *pCmdUI)
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	CListCtrl& refList = GetListCtrl();
	pCmdUI->Enable(refList.GetSelectedCount() == 1);
}

/**
 * IꂽCfbNX擾
 * @return ݑIĂCfbNXlBIĂȂꍇ0
 */
int CRienbuView::GetSelectedIndex() const
{
	CListCtrl& refList = GetListCtrl();
	POSITION pos = refList.GetFirstSelectedItemPosition();
	return refList.GetNextSelectedItem(pos);
}

/**
 * ACeʂɔf
 */
void CRienbuView::SetItemsToList()
{
	CListCtrl& refList = GetListCtrl();
	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();

	int nItem;
	CCommandItem* pItem;
	for (int i = 0; i < pApp->GetItemCount(); i++) {
		pItem = pApp->GetItem(i);
		m_imagesmall.Add(pItem->GetIcon());	// ACR𑫂
		nItem = refList.InsertItem(i, pItem->GetMenuTitle(), i);	// O
		refList.SetItemData(nItem, (DWORD_PTR) pItem);	// f[^ƃXgт
		refList.SetItem(i, 1, LVIF_TEXT, pItem->GetComment(), 0, 0, 0, 0);	// fBNg
	}
}

/**
 * XgŃ_uNbNꂽ
 * @param pResult [out] _uNbÑ^[l̃Zbg
 */
void CRienbuView::OnNMDblclk(NMHDR* /*pNMHDR*/, LRESULT *pResult)
{
	*pResult = 0;
	OnPropitem();
}

/**
 * XgŉENbNꂽ
 * @param point [in] ENbNꂽʒu
 */
void CRienbuView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ܂B
	int nPos = GetSelectedIndex();

	CMenu menu;
	menu.LoadMenu(IDR_PROPERTYMENU);
	CMenu* pMenu = menu.GetSubMenu(0);
	if (pMenu == NULL) {
		return;
	}

	// j[̃fBXG[u
	if (nPos < 0) {
		pMenu->EnableMenuItem(IDM_PROPITEM, MF_BYCOMMAND | MF_GRAYED);
		pMenu->EnableMenuItem(IDM_DELITEM, MF_BYCOMMAND | MF_GRAYED);
		pMenu->EnableMenuItem(IDM_EXECUTE, MF_BYCOMMAND | MF_GRAYED);
	}
	else {
		// ftHgj[𑾎ɂ
		MENUITEMINFO mii;
		::ZeroMemory(&mii, sizeof(MENUITEMINFO));
		mii.cbSize = sizeof(MENUITEMINFO);
		mii.fMask = MIIM_STATE;
		mii.fState = MFS_ENABLED | MFS_DEFAULT;
		pMenu->SetMenuItemInfo(IDM_PROPITEM, &mii);
	}
	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	if (pApp->GetItemCount() >= MAX_ITEMS) {
		pMenu->EnableMenuItem(IDM_ADDITEM, MF_BYCOMMAND | MF_GRAYED);
	}

	// tH[JXRg[
	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
	PostMessage(WM_NULL);
}

/**
 * ACeǉ̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdateAdditem(CCmdUI *pCmdUI)
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	pCmdUI->Enable(pApp->GetItemCount() < MAX_ITEMS);
}

/**
 * ACes
 */
void CRienbuView::OnExecute()
{
	CListCtrl& refList = GetListCtrl();
	int nIndex = GetSelectedIndex();
	if (nIndex < 0) {
		return;
	}
	((CRienbuApp*) ::AfxGetApp())->ExecItem(nIndex);
}

/**
 * ACes̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdateExecute(CCmdUI *pCmdUI)
{
	CListCtrl& refList = GetListCtrl();
	pCmdUI->Enable(refList.GetSelectedCount() == 1);
}

/**
 * ACeւ̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdateUp(CCmdUI *pCmdUI)
{
	int nIndex = GetSelectedIndex();
	BOOL bEnable = ((nIndex > 0) ? TRUE : FALSE);
	pCmdUI->Enable(bEnable);
}

/**
 * ACeւ̕\Ԃ肷
 * @param pCmdUI [in, out] ACe\Ԃ߂IuWFNg
 */
void CRienbuView::OnUpdateDown(CCmdUI *pCmdUI)
{
	BOOL bEnable = FALSE;
	int nIndex = GetSelectedIndex();
	if (nIndex > -1) {
		CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
		if (pApp->GetItemCount() > (nIndex + 1)) {
			bEnable = TRUE;
		}
	}
	pCmdUI->Enable(bEnable);
}

/**
 * ACe
 */
void CRienbuView::OnUp()
{
	int nIndex = GetSelectedIndex();
	if (nIndex > 0) {
		// 1̍蒼
		CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
		CCommandItem* pNewItem = new CCommandItem(*(pApp->GetItem(nIndex - 1)));
		if (pApp->AddItem(pNewItem, nIndex) != FALSE) {
			// ̃ACe폜
			pApp->DeleteItem(nIndex - 1);
			CListCtrl& refList = GetListCtrl();
			refList.DeleteItem(nIndex - 1);
			// VKACeǉ
			int nImage = m_imagesmall.Add(pNewItem->GetIcon());	// ACR𑫂
			int nItem = refList.InsertItem(nIndex, pNewItem->GetMenuTitle(), nImage);	// O
			refList.SetItemData(nItem, (DWORD_PTR) pNewItem);	// f[^ƃXgт
			refList.SetItem(nItem, 1, LVIF_TEXT, pNewItem->GetComment(), 0, 0, 0, 0);	// fBNg
			refList.SetItemState(nIndex - 1, LVIS_SELECTED, LVIS_SELECTED);	// Is
		}
		else {
			delete pNewItem;	// s
		}
	}
}

/**
 * ACe
 */
void CRienbuView::OnDown()
{
	int nIndex = GetSelectedIndex();
	CRienbuApp* pApp = (CRienbuApp*) ::AfxGetApp();
	if ((nIndex > -1) && (pApp->GetItemCount() > (nIndex + 1))) {
		// ̍蒼
		CCommandItem* pNewItem = new CCommandItem(*(pApp->GetItem(nIndex)));
		if (pApp->AddItem(pNewItem, nIndex + 1) != FALSE) {
			// 폜
			pApp->DeleteItem(nIndex);
			CListCtrl& refList = GetListCtrl();
			refList.DeleteItem(nIndex);
			// Vǉ
			int nImage = m_imagesmall.Add(pNewItem->GetIcon());	// ACR𑫂
			int nItem = refList.InsertItem(nIndex + 1, pNewItem->GetMenuTitle(), nImage);	// O
			refList.SetItemData(nItem, (DWORD_PTR) pNewItem);	// f[^ƃXgт
			refList.SetItem(nItem, 1, LVIF_TEXT, pNewItem->GetComment(), 0, 0, 0, 0);	// fBNg
			refList.SetItemState(nItem, LVIS_SELECTED, LVIS_SELECTED);	// Is
		}
		else {
			delete pNewItem;	// s
		}
	}
}

/**
 * WM_CHARnh
 * @param nChar [in] L[̒l
 * @param nRepCnt [in] s[gJEg
 * @param nFlags [in] XLR[h
 */
void CRienbuView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (((CRienbuApp*) ::AfxGetApp())->GetStartupMode() == MODE_NORMAL) {
		if (::AfxGetMainWnd()->IsWindowVisible() != FALSE) {
			if (nChar == VK_ESCAPE) {
				// ̎̃AvP[V̓GXP[vŕȂĂ
				::AfxGetMainWnd()->PostMessage(WM_SYSCOMMAND, (WPARAM) SC_CLOSE);
			}
		}
	}

	CListView::OnChar(nChar, nRepCnt, nFlags);
}
